/*
This file is part of the Juju GUI, which lets users view and manage Juju
environments within a graphical interface (https://launchpad.net/juju-gui).
Copyright (C) 2016 Canonical Ltd.

This program is free software: you can redistribute it and/or modify it under
the terms of the GNU Affero General Public License version 3, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranties of MERCHANTABILITY,
SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero
General Public License for more details.

You should have received a copy of the GNU Affero General Public License along
with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

'use strict';

YUI.add('deployment-machines', function () {

  juju.components.DeploymentMachines = React.createClass({
    propTypes: {
      acl: React.PropTypes.object.isRequired,
      cloud: React.PropTypes.object
    },

    /**
      Generate the list of machines
       @method _generateMachines
      @returns {Object} The list of machines.
    */
    _generateMachines: function _generateMachines() {
      // Create a fake list of machines until we can get the correct data.
      var machines = [1, 2];
      if (!machines || machines.length === 0) {
        return;
      }
      var machineList = machines.map(function (machine, i) {
        return React.createElement(
          'li',
          { className: 'deployment-flow__row twelve-col',
            key: i },
          React.createElement(
            'div',
            { className: 'eight-col' },
            'Trusty, 1x1GHz, 1.70GB, 8.00GB'
          ),
          React.createElement(
            'div',
            { className: 'three-col' },
            'Google'
          ),
          React.createElement(
            'div',
            { className: 'one-col last-col' },
            '4'
          )
        );
      });
      return React.createElement(
        'ul',
        { className: 'deployment-machines__list' },
        React.createElement(
          'li',
          { className: 'deployment-flow__row-header twelve-col' },
          React.createElement(
            'div',
            { className: 'eight-col' },
            'Type'
          ),
          React.createElement(
            'div',
            { className: 'three-col' },
            'Provider'
          ),
          React.createElement(
            'div',
            { className: 'one-col last-col' },
            'Quantity'
          )
        ),
        machineList
      );
    },

    render: function render() {
      var chargeMessage = '';
      if (this.props.cloud && this.props.cloud.id !== 'local') {
        chargeMessage = 'You will incur a charge from your cloud provider.';
      }
      return React.createElement(
        'div',
        null,
        React.createElement(
          'p',
          { className: 'deployment-machines__message' },
          'These machines will be provisioned on ',
          this.props.cloud && this.props.cloud.title,
          '.',
          chargeMessage
        ),
        this._generateMachines()
      );
    }

  });
}, '0.1.0', {
  requires: ['svg-icon']
});