'use strict';var juju={components:{}};describe('DateDisplay',function(){var date,instance,relative,renderer,timers;beforeAll(function(done){YUI().use('date-display',function(){done();});});beforeEach(function(){timers=sinon.useFakeTimers();date=new Date('Mon, 19 Jan 2020 21:07:24 GMT');relative=new Date(date.getTime());renderer=jsTestUtils.shallowRender(React.createElement(juju.components.DateDisplay,{date:relative}),true);instance=renderer.getMountedInstance();sinon.stub(instance,'_getNow').returns(date);});afterEach(function(){timers.restore();});it('can display a date in the correct format',function(){var output=renderer.render(React.createElement(juju.components.DateDisplay,{date:relative}));var expected=React.createElement('time',{dateTime:'19/01/2020',title:'19/01/2020 21:07'},'19/01/2020');assert.deepEqual(output,expected);});it('can parse a date from a string',function(){var output=renderer.render(React.createElement(juju.components.DateDisplay,{date:'Mon, 19 Jan 2020 21:07:24 GMT'}));var expected=React.createElement('time',{dateTime:'19/01/2020',title:'19/01/2020 21:07'},'19/01/2020');assert.deepEqual(output,expected);});it('can display a relative date that is less than a minute ago',function(){relative.setSeconds(date.getSeconds()+10);var output=renderer.render(React.createElement(juju.components.DateDisplay,{date:relative,relative:true}));var expected=React.createElement('time',{dateTime:'19/01/2020',title:'19/01/2020 21:07'},'just now');assert.deepEqual(output,expected);});it('can display a relative date that is a minute ago',function(){relative.setMinutes(date.getMinutes()-1);var output=renderer.render(React.createElement(juju.components.DateDisplay,{date:relative,relative:true}));var expected=React.createElement('time',{dateTime:'19/01/2020',title:'19/01/2020 21:06'},'1 minute ago');assert.deepEqual(output,expected);});it('can display a relative date that is minutes ago',function(){relative.setMinutes(date.getMinutes()-19);var output=renderer.render(React.createElement(juju.components.DateDisplay,{date:relative,relative:true}));var expected=React.createElement('time',{dateTime:'19/01/2020',title:'19/01/2020 20:48'},'19 minutes ago');assert.deepEqual(output,expected);});it('can display a relative date that is an hour ago',function(){relative.setHours(date.getHours()-1);var output=renderer.render(React.createElement(juju.components.DateDisplay,{date:relative,relative:true}));var expected=React.createElement('time',{dateTime:'19/01/2020',title:'19/01/2020 20:07'},'1 hour ago');assert.deepEqual(output,expected);});it('can display a relative date that is hours ago',function(){relative.setHours(date.getHours()-11);var output=renderer.render(React.createElement(juju.components.DateDisplay,{date:relative,relative:true}));var expected=React.createElement('time',{dateTime:'19/01/2020',title:'19/01/2020 10:07'},'11 hours ago');assert.deepEqual(output,expected);});it('can display a relative date that is a day ago',function(){relative.setUTCDate(date.getUTCDate()-1);var output=renderer.render(React.createElement(juju.components.DateDisplay,{date:relative,relative:true}));var expected=React.createElement('time',{dateTime:'18/01/2020',title:'18/01/2020 21:07'},'1 day ago');assert.deepEqual(output,expected);});it('can display a relative date that is days ago',function(){relative.setUTCDate(date.getUTCDate()-6);var output=renderer.render(React.createElement(juju.components.DateDisplay,{date:relative,relative:true}));var expected=React.createElement('time',{dateTime:'13/01/2020',title:'13/01/2020 21:07'},'6 days ago');assert.deepEqual(output,expected);});it('can display a relative date that is a week ago',function(){relative.setUTCDate(date.getUTCDate()-8);var output=renderer.render(React.createElement(juju.components.DateDisplay,{date:relative,relative:true}));var expected=React.createElement('time',{dateTime:'11/01/2020',title:'11/01/2020 21:07'},'1 week ago');assert.deepEqual(output,expected);});it('can display a relative date that is weeks ago',function(){relative.setUTCDate(date.getUTCDate()-25);var output=renderer.render(React.createElement(juju.components.DateDisplay,{date:relative,relative:true}));var expected=React.createElement('time',{dateTime:'25/12/2019',title:'25/12/2019 21:07'},'3 weeks ago');assert.deepEqual(output,expected);});it('can display a relative date that is a month ago',function(){relative.setUTCDate(date.getUTCDate()-32);var output=renderer.render(React.createElement(juju.components.DateDisplay,{date:relative,relative:true}));var expected=React.createElement('time',{dateTime:'18/12/2019',title:'18/12/2019 21:07'},'1 month ago');assert.deepEqual(output,expected);});it('can display a relative date that is months ago',function(){relative.setUTCDate(date.getUTCDate()-100);var output=renderer.render(React.createElement(juju.components.DateDisplay,{date:relative,relative:true}));var expected=React.createElement('time',{dateTime:'11/10/2019',title:'11/10/2019 21:07'},'3 months ago');assert.deepEqual(output,expected);});it('can display a relative date as regular that is years ago',function(){relative.setUTCDate(date.getUTCDate()-450);var output=renderer.render(React.createElement(juju.components.DateDisplay,{date:relative,relative:true}));var expected=React.createElement('time',{dateTime:'26/10/2018',title:'26/10/2018 21:07'},'26/10/2018');assert.deepEqual(output,expected);});it('does not set a timer if the date is not relative',function(){renderer.render(React.createElement(juju.components.DateDisplay,{date:relative,relative:false}));var forceUpdate=sinon.stub(instance,'forceUpdate');instance.componentDidMount();timers.tick(120000);assert.equal(forceUpdate.callCount,0);});it('updates relative dates every minute',function(){renderer.render(React.createElement(juju.components.DateDisplay,{date:relative,relative:true}));var forceUpdate=sinon.stub(instance,'forceUpdate');instance.componentDidMount();timers.tick(120000);assert.equal(forceUpdate.callCount,2);});it('clears the timer when it unmounts',function(){renderer.render(React.createElement(juju.components.DateDisplay,{date:relative,relative:true}));instance.componentDidMount();assert.isNotNull(instance.timer);instance.componentWillUnmount();assert.isNull(instance.timer);});});