'use strict';var juju={components:{}};var testUtils=React.addons.TestUtils;chai.config.includeStack=true;chai.config.truncateThreshold=0;describe('ScaleService',function(){var acl;beforeAll(function(done){YUI().use('scale-service',function(){done();});});beforeEach(function(){acl={isReadOnly:sinon.stub().returns(false)};});it('hides the constraints on initial rendering',function(){var output=jsTestUtils.shallowRender(React.createElement(juju.components.ScaleService,{acl:acl,addGhostAndEcsUnits:sinon.stub(),changeState:sinon.stub(),createMachinesPlaceUnits:sinon.stub(),serviceId:'123'}));var child=output.props.children[2];assert.equal(child.props.className,'scale-service--constraints hidden');});it('hides and shows constraints based on deployment option',function(){var output=testUtils.renderIntoDocument(React.createElement(juju.components.ScaleService,{acl:acl,addGhostAndEcsUnits:sinon.stub(),changeState:sinon.stub(),createMachinesPlaceUnits:sinon.stub(),serviceId:'123'}));var autoToggle=output.refs.autoPlaceUnitsToggle;var constraints=output.refs.constraintsContainer;assert.isTrue(constraints.classList.contains('hidden'));testUtils.Simulate.change(autoToggle);assert.isFalse(constraints.classList.contains('hidden'));});it('creates and autoplaces units if constraints is open',function(){var addGhostStub=sinon.stub();var createMachineStub=sinon.stub();var changeStateStub=sinon.stub();var output=testUtils.renderIntoDocument(React.createElement(juju.components.ScaleService,{acl:acl,serviceId:'123',addGhostAndEcsUnits:addGhostStub,createMachinesPlaceUnits:createMachineStub,changeState:changeStateStub}));var unitCount=output.refs.numUnitsInput;unitCount.value=3;testUtils.Simulate.change(unitCount);testUtils.Simulate.change(output.refs.autoPlaceUnitsToggle);var constraintsContainer=output.refs.constraintsContainer;var cpu=constraintsContainer.querySelector('input[name="cpu-constraint"]');cpu.value='c p u';testUtils.Simulate.change(cpu);var cores=constraintsContainer.querySelector('input[name="cores-constraint"]');cores.value='c o r e s';testUtils.Simulate.change(cores);var ram=constraintsContainer.querySelector('input[name="mem-constraint"]');ram.value='r a m';testUtils.Simulate.change(ram);var disk=constraintsContainer.querySelector('input[name="disk-constraint"]');disk.value='d i s k';testUtils.Simulate.change(disk);var form=ReactDOM.findDOMNode(output);testUtils.Simulate.submit(form);assert.equal(createMachineStub.callCount,1);assert.equal(addGhostStub.callCount,0);assert.equal(changeStateStub.callCount,1);assert.equal(createMachineStub.args[0][0],3);assert.deepEqual(createMachineStub.args[0][1],{'cpu-power':'c p u','cpu-cores':'c o r e s','mem':'r a m','root-disk':'d i s k'});assert.deepEqual(changeStateStub.args[0][0],{sectionA:{component:'inspector',metadata:{id:'123',activeComponent:'units'}}});});it('creates and shows the machine view if constraints is closed',function(){var addGhostStub=sinon.stub();var createMachineStub=sinon.stub();var changeStateStub=sinon.stub();var output=testUtils.renderIntoDocument(React.createElement(juju.components.ScaleService,{acl:acl,serviceId:'123',addGhostAndEcsUnits:addGhostStub,createMachinesPlaceUnits:createMachineStub,changeState:changeStateStub}));var unitCount=output.refs.numUnitsInput;unitCount.value=3;testUtils.Simulate.change(unitCount);var form=ReactDOM.findDOMNode(output);testUtils.Simulate.submit(form);assert.equal(createMachineStub.callCount,0);assert.equal(addGhostStub.callCount,1);assert.equal(changeStateStub.callCount,1);assert.equal(addGhostStub.args[0][0],3);assert.deepEqual(changeStateStub.args[0][0],{sectionA:{component:'inspector',metadata:{id:'123',activeComponent:'units'}},sectionB:{component:'machine'}});});it('can disable the controls when read only',function(){acl.isReadOnly=sinon.stub().returns(true);var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.ScaleService,{acl:acl,addGhostAndEcsUnits:sinon.stub(),changeState:sinon.stub(),createMachinesPlaceUnits:sinon.stub(),serviceId:'123'}),true);var instance=renderer.getMountedInstance();var output=renderer.getRenderOutput();var expected=React.createElement('form',{className:'scale-service',onSubmit:instance._scaleUpService},React.createElement('div',{className:'scale-service--units'},React.createElement('input',{className:'scale-service--units__input',disabled:true,type:'number',min:'0',step:'1',autoComplete:'off',name:'num-units',onChange:instance._updateState,ref:'numUnitsInput'}),React.createElement('span',{className:'scale-service--units__span'},'units')),React.createElement('div',{className:'scale-service--selector'},React.createElement('div',null,React.createElement('input',{className:'scale-service--selector__radio',disabled:true,name:'placement',type:'radio',onChange:instance._toggleConstraints,id:'auto-place-units',ref:'autoPlaceUnitsToggle'}),React.createElement('label',{htmlFor:'auto-place-units'},'1 unit per machine')),React.createElement('div',null,React.createElement('input',{className:'scale-service--selector__radio',disabled:true,name:'placement',type:'radio',onChange:instance._toggleConstraints,defaultChecked:true,id:'manually-place-units'}),React.createElement('label',{htmlFor:'manually-place-units'},'Manually place'))),React.createElement('div',{className:'scale-service--constraints hidden',ref:'constraintsContainer'},React.createElement(juju.components.Constraints,{disabled:true,valuesChanged:instance._updateConstraints})),React.createElement(juju.components.ButtonRow,{buttons:[{disabled:true,title:'Confirm',submit:true}]}));assert.deepEqual(output,expected);});});