'use strict';var juju={components:{}};describe('UserProfileModelList',function(){var env,models,users;beforeAll(function(done){YUI().use('user-profile-model-list',function(){done();});});beforeEach(function(){env={destroyModel:sinon.stub().callsArg(0),findFacadeVersion:sinon.stub(),get:sinon.stub().returns('default'),createModel:function createModel(modelName,userName,callback){assert.equal(modelName,'newmodelname','model name not set properly');assert.equal(userName,'test-owner','user name not set properly');callback({err:null,uuid:'abc123',name:modelName});}};models=[{uuid:'model1',name:'spinach/sandbox',lastConnection:'today',ownerTag:'test-owner',isAlive:true}];users={charmstore:{user:'test-owner',usernameDisplay:'test owner'}};});it('renders the empty state',function(){var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),canCreateNew:false,currentModel:'model1',env:env,hideConnectingMask:sinon.stub(),jem:null,listModels:sinon.stub().callsArgWith(0,null,[]),showConnectingMask:sinon.stub(),switchModel:sinon.stub(),user:users.charmstore,users:users}),true);var output=component.getRenderOutput();assert.equal(output,null);});it('displays loading spinner when loading',function(){var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),canCreateNew:false,currentModel:'model1',env:env,hideConnectingMask:sinon.stub(),jem:null,listModels:sinon.stub(),showConnectingMask:sinon.stub(),switchModel:sinon.stub(),user:users.charmstore,users:users}),true);var output=component.getRenderOutput();assert.deepEqual(output,React.createElement('div',{className:'user-profile__model-list twelve-col'},React.createElement(juju.components.Spinner,null)));});it('renders a list of models',function(){var listModels=sinon.stub().callsArgWith(0,null,{models:models});var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),canCreateNew:true,currentModel:'model1',env:env,hideConnectingMask:sinon.stub(),jem:null,listModels:listModels,showConnectingMask:sinon.stub(),switchModel:sinon.stub(),user:users.charmstore,users:users}),true);var instance=component.getMountedInstance();var output=component.getRenderOutput();var expected=React.createElement('div',{className:'user-profile__model-list'},React.createElement('div',{className:'user-profile__header twelve-col no-margin-bottom'},'Models',React.createElement('span',{className:'user-profile__size'},'(',1,')'),React.createElement('div',{className:'user-profile__create-new collapsed'},React.createElement('form',{onSubmit:instance.createAndSwitch},React.createElement(juju.components.GenericButton,{action:instance._nextCreateStep,type:'inline-neutral first',title:'Create new'}),React.createElement(juju.components.GenericInput,{placeholder:'untitled_model',required:true,ref:'modelName',validate:[{regex:/\S+/,error:'This field is required.'},{regex:/^[a-zA-Z0-9]([a-zA-Z0-9.-]*[a-zA-Z0-9])?$/,error:'This field must only contain upper and lowercase '+'letters, numbers, and hyphens. It must not start or '+'end with a hyphen.'}]}),React.createElement(juju.components.GenericButton,{action:instance.createAndSwitch,type:'inline-neutral second',title:'Submit'})))),React.createElement('ul',{className:'user-profile__list twelve-col'},React.createElement('li',{className:'user-profile__list-header twelve-col'},React.createElement('span',{className:'user-profile__list-col three-col'},'Name'),React.createElement('span',{className:'user-profile__list-col four-col'},'Credential'),React.createElement('span',{className:'user-profile__list-col two-col'},'Last accessed'),React.createElement('span',{className:'user-profile__list-col one-col'},'Units'),React.createElement('span',{className:'user-profile__list-col two-col last-col'},'Owner')),[React.createElement(juju.components.UserProfileEntity,{entity:models[0],expanded:true,key:'model1',switchModel:instance.switchModel,type:'model'},React.createElement('span',{className:'user-profile__list-col three-col'},'spinach/sandbox'),React.createElement('span',{className:'user-profile__list-col four-col'},'--'),React.createElement('span',{className:'user-profile__list-col two-col'},'today'),React.createElement('span',{className:'user-profile__list-col one-col'},'--'),React.createElement('span',{className:'user-profile__list-col two-col last-col'},'test-owner'))]));assert.deepEqual(output,expected);});it('can render models that are being destroyed',function(){models[0].isAlive=false;var listModels=sinon.stub().callsArgWith(0,null,{models:models});var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),canCreateNew:false,currentModel:'model1',env:env,hideConnectingMask:sinon.stub(),jem:null,listModels:listModels,showConnectingMask:sinon.stub(),switchModel:sinon.stub(),user:users.charmstore,users:users}),true);var output=component.getRenderOutput();var content=output.props.children[1].props.children[1][0];var expected=React.createElement('li',{className:'user-profile__entity user-profile__list-row',key:'model1'},'spinach/sandbox',' is being destroyed.');assert.deepEqual(content,expected);});it('switches models when calling switchModel method passed to list',function(){var switchModel=sinon.stub();var listModels=sinon.stub().callsArgWith(0,null,{models:models});var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),canCreateNew:true,currentModel:'model1',env:env,hideConnectingMask:sinon.stub(),jem:null,listModels:listModels,showConnectingMask:sinon.stub(),switchModel:switchModel,user:users.charmstore,users:users}),true);var instance=component.getMountedInstance();instance.switchModel('abc123','modelname');assert.equal(switchModel.callCount,1,'switchModel not called');assert.deepEqual(switchModel.args[0],['abc123',[{uuid:'model1',name:'spinach/sandbox',lastConnection:'today',ownerTag:'test-owner',isAlive:true,owner:'test-owner'}],'modelname',undefined]);});it('can reset the model connection',function(){var utilsSwitchModel=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),canCreateNew:true,env:env,hideConnectingMask:sinon.stub(),listModels:sinon.stub(),showConnectingMask:sinon.stub(),switchModel:utilsSwitchModel,users:users,user:users.charmstore}),true);var instance=renderer.getMountedInstance();instance.switchModel();assert.equal(utilsSwitchModel.callCount,1,'Model disconnect not called');var switchArgs=utilsSwitchModel.args[0];assert.equal(switchArgs[0],undefined,'UUID should not be defined');});it('can hide the create new model button',function(){var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),canCreateNew:false,env:env,hideConnectingMask:sinon.stub(),listModels:sinon.stub().callsArgWith(0,null,{models:models}),showConnectingMask:sinon.stub(),switchModel:sinon.stub(),users:users,user:users.charmstore}),true);var output=component.getRenderOutput();assert.isUndefined(output.props.children[0].props.children[2]);});it('creates then switches to newly created models',function(){var showConnectingMask=sinon.stub();var switchModel=sinon.stub();var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),canCreateNew:true,env:env,hideConnectingMask:sinon.stub(),listModels:sinon.stub().callsArgWith(0,null,{models:models}),showConnectingMask:showConnectingMask,switchModel:switchModel,users:users,user:users.charmstore}),true);var output=component.getRenderOutput();var instance=component.getMountedInstance();instance.refs={modelName:{validate:function validate(_){return true;},getValue:function getValue(_){return'newmodelname';}}};var preventable={preventDefault:sinon.stub()};output.props.children[0].props.children[2].props.children.props.children[2].props.action(preventable);assert.equal(preventable.preventDefault.callCount,1,'default not prevented');assert.equal(showConnectingMask.callCount,1,'mask not shown');assert.equal(switchModel.callCount,1,'model not switched to');assert.equal(switchModel.args[0][0],'abc123','uuid not passed through');assert.equal(switchModel.args[0][2],'newmodelname','model name not set');});it('does not submit to create new if name does not validate',function(){var showConnectingMask=sinon.stub();var switchModel=sinon.stub();var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),canCreateNew:true,env:env,hideConnectingMask:sinon.stub(),listModels:sinon.stub().callsArgWith(0,null,{models:models}),showConnectingMask:showConnectingMask,switchModel:switchModel,users:users,user:users.charmstore}),true);var output=component.getRenderOutput();var instance=component.getMountedInstance();instance.refs={modelName:{validate:function validate(_){return false;}}};var preventable={preventDefault:sinon.stub()};output.props.children[0].props.children[2].props.children.props.children[2].props.action(preventable);assert.equal(preventable.preventDefault.callCount,1,'default not prevented');assert.equal(showConnectingMask.callCount,0,'mask shown');assert.equal(switchModel.callCount,0,'model should not be switched to');});it('gracefully handles errors when creating new model',function(){env.createModel=function(modelName,userName,callback){assert.equal(modelName,'newmodelname','model name not set properly');assert.equal(userName,'test-owner','user name not set properly');callback({err:'this is an error',uuid:'abc123',name:modelName});};var hideConnectingMask=sinon.stub();var addNotification=sinon.stub();var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:addNotification,canCreateNew:true,env:env,hideConnectingMask:hideConnectingMask,listModels:sinon.stub().callsArgWith(0,null,{models:models}),showConnectingMask:sinon.stub(),switchModel:sinon.stub(),users:users,user:users.charmstore}),true);var output=component.getRenderOutput();var instance=component.getMountedInstance();instance.refs={modelName:{validate:function validate(_){return true;},getValue:function getValue(_){return'newmodelname';}}};var preventable={preventDefault:sinon.stub()};output.props.children[0].props.children[2].props.children.props.children[2].props.action(preventable);assert.equal(hideConnectingMask.callCount,1,'mask not hidden');assert.equal(addNotification.callCount,1,'notification not added');assert.deepEqual(addNotification.args[0][0],{title:'Failed to create new Model',message:'this is an error',level:'error'});});it('swtches models by switching to disconnected with JIMM',function(){var switchModel=sinon.stub();var showConnectingMask=sinon.stub();env.createModel=sinon.stub();var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),canCreateNew:true,env:env,hideConnectingMask:sinon.stub(),jem:{},listModels:sinon.stub().callsArgWith(0,null,{models:models}),showConnectingMask:showConnectingMask,switchModel:switchModel,users:users,user:users.charmstore}),true);var output=component.getRenderOutput();output.props.children[0].props.children[2].props.children.props.children[0].props.action();assert.equal(showConnectingMask.callCount,0,'should not show mask');assert.equal(env.createModel.callCount,0,'it should not create model');assert.equal(switchModel.callCount,1,'it should have called switchModel');assert.deepEqual(switchModel.args[0],[undefined,[{uuid:'model1',name:'spinach/sandbox',lastConnection:'today',ownerTag:'test-owner',isAlive:true,owner:'test-owner'}],undefined,undefined]);});it('will abort the requests when unmounting',function(){var listModelsAbort=sinon.stub();var listModels=sinon.stub().returns({abort:listModelsAbort});var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),canCreateNew:false,currentModel:'model1',env:env,hideConnectingMask:sinon.stub(),jem:null,listModels:listModels,showConnectingMask:sinon.stub(),switchModel:sinon.stub(),user:users.charmstore,users:users}),true);renderer.unmount();assert.equal(listModelsAbort.callCount,1);});});