'use strict';YUI.add('juju-delta-handlers',function(Y){var models=Y.namespace('juju.models');var utils={cleanUpEntityTags:function cleanUpEntityTags(tag){var result=tag.replace(/^(application|unit|machine|model)-/,'');if(!result){return tag;}var unitPrefix='unit-';if(tag.slice(0,unitPrefix.length)===unitPrefix){result=result.replace(/-(\d+)$/,'/$1');}return result;},convertOpenPorts:function convertOpenPorts(ports){if(!ports){return[];}return ports.map(function(port){return port.number+'/'+port.protocol;});},createEndpoints:function createEndpoints(endpoints){return endpoints.map(function(endpoint){var relation=endpoint.relation;var data={role:relation.role,name:relation.name};return[endpoint['application-name'],data];});},convertConstraints:function convertConstraints(constraints){var result=constraints||{};var tags=result.tags||[];delete result.tags;if(tags.length){result.tags=tags.join(',');}return result;},translateToLegacyAgentState:function translateToLegacyAgentState(currentStatus,workloadStatus,workloadStatusMessage){var statusMaintenance='maintenance';var statusAllocating='allocating';var statusPending='pending';var statusError='error';var statusRebooting='rebooting';var statusExecuting='executing';var statusIdle='idle';var statusLost='lost';var statusFailed='failed';var statusTerminated='terminated';var statusStarted='started';var statusStopped='stopped';var messageInstalling='installing charm software';var isInstalled=workloadStatus!=statusMaintenance||workloadStatusMessage!=messageInstalling;switch(currentStatus){case statusAllocating:return statusPending;break;case statusError:return statusError;break;case statusRebooting:case statusExecuting:case statusIdle:case statusLost:case statusFailed:switch(workloadStatus){case statusError:return statusError;break;case statusTerminated:return statusStopped;break;case statusMaintenance:return isInstalled?statusStarted:statusPending;break;default:return statusStarted;break;}break;}}};models.utils=utils;var applicationChangedHooks=Object.create(null);models._applicationChangedHooks=applicationChangedHooks;models.handlers={defaultHandler:function defaultHandler(db,action,change,kind){console.error('Unknown delta type: '+kind);console.log(action,change);},unitInfo:function unitInfo(db,action,change){var unitData={id:change.name,charmUrl:change['charm-url'],service:change.application,machine:change['machine-id'],public_address:change['public-address'],private_address:change['private-address'],open_ports:utils.convertOpenPorts(change.ports),subordinate:change.subordinate,workloadStatusMessage:''};var agentStatus=change['agent-status']||{};var workloadStatus=change['workload-status']||{};unitData.workloadStatusMessage=workloadStatus.message;if(workloadStatus.current==='error'){unitData.agent_state=workloadStatus.current;unitData.agent_state_info=workloadStatus.message;unitData.agent_state_data=workloadStatus.data;}else{unitData.agent_state=utils.translateToLegacyAgentState(agentStatus.current,workloadStatus.current,workloadStatus.message);unitData.agent_state_info=agentStatus.message;unitData.agent_state_data=agentStatus.data;}db.units.process_delta(action,unitData,db);if(unitData.machine){db.machines.process_delta('change',{id:unitData.machine,public_address:unitData.public_address},db);}},applicationInfo:function applicationInfo(db,action,change){var data={id:change.name,name:change.name,charm:change['charm-url'],exposed:change.exposed,life:change.life,constraints:utils.convertConstraints(change.constraints),subordinate:change.subordinate};db.services.process_delta(action,data);if(action!=='remove'){db.services.getById(change.name).updateConfig(change.config||{});var hooks=applicationChangedHooks[change.name]||[];hooks.forEach(function(hook){hook();});}delete applicationChangedHooks[change.name];},remoteapplicationInfo:function remoteapplicationInfo(db,action,change){var status=change.status||{};var data={id:change['application-url'],service:change.name,sourceId:change['model-uuid'],life:change.life,status:{current:status.current,message:status.message,data:status.data,since:status.since}};db.remoteServices.process_delta(action,data);},relationInfo:function relationInfo(db,action,change){var endpoints=change.endpoints;var firstEp=endpoints[0];var firstRelation=firstEp.relation;var data={id:change.key,'interface':firstRelation.interface,scope:firstRelation.scope,endpoints:utils.createEndpoints(endpoints)};var processRelation=function processRelation(){db.relations.process_delta(action,data,db);};var applicationName=firstEp['application-name'];if(!db.services.getById(applicationName)){console.log('relation change',change.key,'delayed, waiting for missing application',applicationName);var hooks=applicationChangedHooks[applicationName]||[];hooks.push(processRelation);applicationChangedHooks[applicationName]=hooks;return;}processRelation();},machineInfo:function machineInfo(db,action,change){var addresses=change.addresses||[];var status=change['agent-status']||{};var data={id:change.id,addresses:addresses.map(function(address){return{name:address['space-name'],scope:address.scope,type:address.type,value:address.value};}),instance_id:change['instance-id'],agent_state:status.current,agent_state_info:status.message||'',agent_state_data:status.data,hardware:{},jobs:change.jobs,life:change.life,series:change.series,supportedContainers:null};var hardwareCharacteristics=change['hardware-characteristics'];if(hardwareCharacteristics){data.hardware={arch:hardwareCharacteristics.arch,cpuCores:hardwareCharacteristics['cpu-cores'],cpuPower:hardwareCharacteristics['cpu-power'],mem:hardwareCharacteristics.mem,disk:hardwareCharacteristics['root-disk'],availabilityZone:hardwareCharacteristics['availability-zone']};}if(change['supported-containers-known']){data.supportedContainers=change['supported-containers'];}db.machines.process_delta(action,data);},annotationInfo:function annotationInfo(db,action,change){var tag=change.tag,kind=tag.split('-')[0],id=utils.cleanUpEntityTags(tag),instance;if(kind==='model'){instance=db.environment;}else{instance=db.resolveModelByName(id);}if(!instance){return;}models.setAnnotations(instance,change.annotations,true);if(instance.name==='serviceUnit'){var application=db.services.getById(instance.service);if(application){var applicationUnits=application.get('units');if(applicationUnits){var nestedInstance=applicationUnits.getById(id);models.setAnnotations(nestedInstance,change.annotations,true);}}}}};},'0.1.0',{requires:['base','array-extras']});