'use strict';YUI.add('juju-env-api',function(Y){var PING_INTERVAL=10;var ADMIN_FACADE_VERSION=3;var ERR_STOP_WATCHER='watcher was stopped';var environments=Y.namespace('juju.environments');var utils=Y.namespace('juju.views.utils');var _getCharmAPIPath=function _getCharmAPIPath(uuid,query){var prefix='/model/'+uuid+'/charms?';if(!window.juju_config||!window.juju_config.staticURL){prefix='/juju-core'+prefix;}return prefix+query;};var endpointToName=function endpointToName(endpoint){if(!endpoint[1].name){return endpoint[0];}return endpoint[0]+':'+endpoint[1].name;};var createRelationKey=function createRelationKey(endpoints){var roles=Object.create(null);Y.each(endpoints,function(value,key){roles[value.role]=key+':'+value.name;});return roles.requirer+' '+roles.provider;};var lowerObjectKeys=function lowerObjectKeys(obj){var newObj=Object.create(null);Y.each(obj,function(value,key){newObj[key.toLowerCase()]=value;});return newObj;};var MACHINE_SCOPE='#';var parsePlacement=function parsePlacement(toMachine){if(!toMachine){return null;}var parts=toMachine.split(':');if(parts.length===2){return{scope:parts[0],directive:parts[1]};}var part=parts[0];if(part===LXC.value||part===LXD.value||part===KVM.value){return{scope:part,directive:''};}return{scope:MACHINE_SCOPE,directive:part};};var stringifyObjectValues=function stringifyObjectValues(obj){var newObj=Object.create(null);Y.each(obj,function(value,key){if(value===null){newObj[key]=value;}else{newObj[key]=value+'';}});return newObj;};var machineJobs={HOST_UNITS:'JobHostUnits',MANAGE_ENVIRON:'JobManageEnviron'};function GoEnvironment(config){GoEnvironment.superclass.constructor.apply(this,arguments);}GoEnvironment.NAME='api-env';Y.extend(GoEnvironment,environments.BaseEnvironment,{genericConstraints:['cpu-power','cpu-cores','mem','arch','tags','root-disk'],integerConstraints:['cpu-power','cpu-cores','mem','root-disk'],series:Object.keys(utils.getSeriesList()),initializer:function initializer(){this.defaultUser='admin';this._allWatcherId=null;this._pinger=null;this.pendingLoginResponse=false;this.on('_rpc_response',this._handleRpcResponse);this._allWatcherBeingStopped=false;},dispatch_result:function dispatch_result(data){var tid=data['request-id'];if(tid in this._txn_callbacks){this._txn_callbacks[tid].call(this,data);delete this._txn_callbacks[tid];}},_send_rpc:function _send_rpc(op,callback){var facade=op.type;var version=op.version;if(facade!=='Admin'){version=this.findFacadeVersion(facade,version);}if(version===null){var err='api client: operation not supported: '+JSON.stringify(op);console.error(err);if(callback){callback({error:err});}return;}if(this.ws.readyState!==1){console.log('Websocket is not open, dropping request. '+'readyState: '+this.ws.readyState,op);return;}op.version=version;var tid=this._counter+=1;if(callback){this._txn_callbacks[tid]=callback;}op['request-id']=tid;if(!op.params){op.params={};}var msg=Y.JSON.stringify(op);this.ws.send(msg);},_watchAll:function _watchAll(){this._send_rpc({type:'Client',request:'WatchAll'},function(data){if(data.error){console.error('cannot start the mega-watcher');return;}this._allWatcherId=data.response['watcher-id'];this._next();});},_handleRpcResponse:function _handleRpcResponse(data){this._next();var deltas=[],cmp={applicationInfo:1,relationInfo:2,unitInfo:3,machineInfo:4,annotationInfo:5,remoteapplicationInfo:100};data.response.deltas.forEach(function(delta){var kind=delta[0],operation=delta[1],entityInfo=delta[2];deltas.push([kind+'Info',operation,entityInfo]);});deltas.sort(function(a,b){if(!cmp[a[0]]){return 1;}if(!cmp[b[0]]){return-1;}var scoreA=cmp[a[0]];var scoreB=cmp[b[0]];if(a[1]==='remove'){scoreA=-scoreA;}if(b[1]==='remove'){scoreB=-scoreB;}return scoreA-scoreB;});this.fire('delta',{data:{result:deltas}});},_next:function _next(){this._send_rpc({type:'AllWatcher',request:'Next',id:this._allWatcherId},function(data){if(!data.error){this.fire('_rpc_response',data);return;}if(this._allWatcherBeingStopped&&data.error===ERR_STOP_WATCHER){this._allWatcherBeingStopped=false;return;}console.error('cannot get next changes from the mega-watcher:',data.error);});},_stopWatching:function _stopWatching(callback){var cb=function(){this._allWatcherId=null;callback();}.bind(this);this._allWatcherBeingStopped=true;this._send_rpc({type:'AllWatcher',request:'Stop',id:this._allWatcherId},cb);},prepareConstraints:function prepareConstraints(constraints){if(typeof constraints==='string'){var constraintsObj={};constraints.trim().split(/\s+/).forEach(function(constraint){var constraintParts=constraint.trim().split('=');if(constraintParts.length!==2){console.error('Got unexpected malformed constraint',constraint);return;}constraintsObj[constraintParts[0].trim()]=constraintParts[1].trim();});constraints=constraintsObj;}var result=Object.create(null);Object.keys(constraints).forEach(function(key){var value;if(this.integerConstraints.indexOf(key)!==-1){value=parseInt(constraints[key],10);}else if(this.genericConstraints.indexOf(key)!==-1){value=(constraints[key]||'').trim();}if(value||value===0){result[key]=value;}},this);var tags=result.tags;if(tags){result.tags=tags.split(',').reduce(function(collected,value){var tag=value.trim().split(/\s+/).join('-');if(tag){collected.push(tag);}return collected;},[]);}return result;},handleLogin:function handleLogin(data){this.pendingLoginResponse=false;this.userIsAuthenticated=!data.error;if(this.userIsAuthenticated){var response=data.response;var facadeList=response.facades||[];var facades=facadeList.reduce(function(previous,current){previous[current.name]=current.versions;return previous;},{});this.set('facades',facades);var userInfo=response['user-info'];this.set('readOnly',!!userInfo['read-only']);this.currentModelInfo();this._watchAll();if(!this._pinger){this._pinger=setInterval(this.ping.bind(this),PING_INTERVAL*1000);}this.failedAuthentication=false;}else{this.setCredentials(null);this.failedAuthentication=true;}this.fire('login',{data:{result:this.userIsAuthenticated,error:data.error||null}});},findFacadeVersion:function findFacadeVersion(name,version){var facades=this.get('facades')||{};var versions=facades[name]||[];if(!versions.length){return null;}if(version===undefined||version===null){return versions[versions.length-1];}if(versions.indexOf(version)>-1){return version;}return null;},login:function login(){if(this.userIsAuthenticated){this.fire('login',{data:{result:true}});return;}if(this.pendingLoginResponse){return;}var credentials=this.getCredentials();if(!credentials.user||!credentials.password){console.warn('attempted login without providing credentials');this.fire('login',{data:{result:false}});return;}this._send_rpc({type:'Admin',request:'Login',params:{'auth-tag':credentials.user,credentials:credentials.password},version:ADMIN_FACADE_VERSION},this.handleLogin);this.pendingLoginResponse=true;},loginWithMacaroon:function loginWithMacaroon(bakery,callback){if(this.pendingLoginResponse){return;}var cback=function(err,response){this.handleLogin({error:err,response:response});if(callback){callback(err);return;}if(err){console.warn('macaroon authentication failed:',err);return;}console.debug('macaroon authentication succeeded');}.bind(this);var handleResponse=function handleResponse(bakery,macaroons,cback,data){var _this=this;if(data.error){cback('authentication failed: '+data.error);return;}var response=data.response;var macaroon=response['discharge-required'];if(macaroon){bakery.discharge(macaroon,function(macaroons){sendLoginRequest(macaroons,handleResponse.bind(_this,bakery,macaroons,cback));},function(msg){cback('macaroon discharge failed: '+msg);});return;}var user=response['user-info']&&response['user-info'].identity;if(!user){cback('authentication failed: use a proper Juju 2 release');return;}this.setCredentials({macaroons:macaroons,user:user});cback(null,response);};var sendLoginRequest=function(macaroons,callback){var request={type:'Admin',request:'Login',version:ADMIN_FACADE_VERSION};if(macaroons){request.params={macaroons:[macaroons]};}this._send_rpc(request,callback);}.bind(this);var macaroons=this.getCredentials().macaroons;sendLoginRequest(macaroons,handleResponse.bind(this,bakery,macaroons,cback));this.pendingLoginResponse=true;},beforeClose:function beforeClose(callback){if(this._pinger){clearInterval(this._pinger);this._pinger=null;}this._stopWatching(callback);},ping:function ping(){this._send_rpc({type:'Pinger',request:'Ping'});},_handleCurrentModelInfo:function _handleCurrentModelInfo(data){var _this2=this;if(data.error){console.warn('error retrieving model information');return;}var response=data.response;this.set('defaultSeries',response['default-series']);this.set('providerType',response['provider-type']);this.set('environmentName',response.name);this.set('modelUUID',response.uuid);if(response['provider-type']!=='maas'){this.set('maasServer',null);return;}this.modelGet(function(data){if(data.err){console.warn('error calling ModelGet API: '+data.err);return;}_this2.set('maasServer',data.config['maas-server']);});},currentModelInfo:function currentModelInfo(){this._send_rpc({type:'Client',request:'ModelInfo'},this._handleCurrentModelInfo);},modelInfo:function modelInfo(tags,callback){var handler=function(userCallback,tags,data){if(!userCallback){console.log('data returned by model info API call:',data);return;}var err=data.error&&data.error.message;if(err){userCallback({err:err});return;}var results=data.response.results;if(results.length!==tags.length){userCallback({err:'unexpected results: '+JSON.stringify(results)});return;}var models=results.map(function(result,index){err=result.error&&result.error.message;if(err){return{tag:tags[index],err:err};}result=result.result;return{tag:tags[index],name:result.name,series:result['default-series'],provider:result['provider-type'],uuid:result.uuid,serverUuid:result['controller-uuid'],ownerTag:result['owner-tag'],life:result.life,isAlive:result.life==='alive',isAdmin:result.uuid===result['controller-uuid']};});userCallback({models:models});}.bind(this,callback,tags);var entities=tags.map(function(tag){return{tag:tag};});this._send_rpc({type:'ModelManager',request:'ModelInfo',params:{entities:entities}},handler);},listModelsWithInfo:function listModelsWithInfo(callback){var _this3=this;if(!callback){callback=function callback(err,data){console.log('listModelsWithInfo: No callback provided');if(err){console.log('listModelsWithInfo: API call error:',err);}else{console.log('listModelsWithInfo: API call data:',data);}};}var credentials=this.getCredentials();if(!credentials.user){callback('called without credentials',null);return;}this.listModels(credentials.user,function(listData){if(listData.err){callback(listData.err,null);return;}var tags=listData.envs.map(function(model){return model.tag;});_this3.modelInfo(tags,function(infoData){if(infoData.err){callback(infoData.err,null);return;}var models=infoData.models.map(function(model,index){if(model.err){return{tag:model.tag,err:model.err};}return{tag:model.tag,name:model.name,series:model.series,provider:model.provider,uuid:model.uuid,serverUuid:model.serverUuid,ownerTag:model.ownerTag,life:model.life,isAlive:model.isAlive,isAdmin:model.isAdmin,lastConnection:listData.envs[index].lastConnection};});callback(null,{models:models});});});},modelGet:function modelGet(callback){var intermediateCallback;if(callback){intermediateCallback=this._handleModelGet.bind(null,callback);}this._send_rpc({type:'Client',request:'ModelGet'},intermediateCallback);},_handleModelGet:function _handleModelGet(callback,data){var transformedData={err:data.error};if(!data.error){transformedData.config=data.response.config;}callback(transformedData);},uploadLocalCharm:function uploadLocalCharm(file,series,progress,callback){if(!this.userIsAuthenticated){console.warn('Attempted upload files without providing credentials.');this.fire('login',{data:{result:false}});return;}var credentials=this.getCredentials();var path=_getCharmAPIPath(this.get('modelUUID'),'series='+series);var headers={'Content-Type':'application/zip'};var webHandler=this.get('webHandler');webHandler.sendPostRequest(path,headers,file,credentials.user,credentials.password,progress,callback);},getLocalCharmFileUrl:function getLocalCharmFileUrl(charmUrl,filename){var credentials=this.getCredentials();var path=_getCharmAPIPath(this.get('modelUUID'),'url='+charmUrl+'&file='+filename);var webHandler=this.get('webHandler');return webHandler.getUrl(path,credentials.user,credentials.password);},_jujuHttpGet:function _jujuHttpGet(path,progress,callback){var credentials=this.getCredentials();var webHandler=this.get('webHandler');var headers=Object.create(null);webHandler.sendGetRequest(path,headers,credentials.user,credentials.password,progress,callback);},listLocalCharmFiles:function listLocalCharmFiles(charmUrl,progress,callback){var path=_getCharmAPIPath(this.get('modelUUID'),'url='+charmUrl);this._jujuHttpGet(path,progress,callback);},getLocalCharmFileContents:function getLocalCharmFileContents(charmUrl,filename,progress,callback){var path=_getCharmAPIPath(this.get('modelUUID'),'url='+charmUrl+'&file='+filename);this._jujuHttpGet(path,progress,callback);},addCharm:function addCharm(url,macaroon,callback,options){var ecs=this.get('ecs');var args=ecs._getArgs(arguments);if(options&&options.immediate){this._addCharm.apply(this,args);}else{ecs._lazyAddCharm(arguments);}},_addCharm:function _addCharm(url,macaroon,callback){var handleAddCharm=function(userCallback,url,data){if(!userCallback){console.log('data returned by addCharm API call:',data);return;}userCallback({err:data.error,url:url});}.bind(this,callback,url);var request={type:'Client',request:'AddCharm',params:{url:url}};if(macaroon){request.request='AddCharmWithAuthorization';request.params.macaroon=macaroon;}this._send_rpc(request,handleAddCharm);},deploy:function deploy(charmUrl,series,applicationName,config,configRaw,numUnits,constraints,toMachine,callback,options){var ecs=this.get('ecs');var args=ecs._getArgs(arguments);if(options&&options.immediate){this._deploy.apply(this,args);}else{ecs._lazyDeploy(arguments);}},_deploy:function _deploy(charmUrl,series,applicationName,config,configRaw,numUnits,constraints,toMachine,callback){var handler=function(userCallback,applicationName,charmUrl,data){if(!userCallback){console.log('data returned by deploy API call:',data);return;}var result=data.response.results[0];userCallback({err:result.error,applicationName:applicationName,charmUrl:charmUrl});}.bind(this,callback,applicationName,charmUrl);if(constraints){if(typeof constraints==='function'){console.error('Constraints need to be an object not a function');console.warn(constraints);}constraints=this.prepareConstraints(constraints);}else{constraints={};}var params={application:applicationName,'charm-url':charmUrl,config:stringifyObjectValues(config),'config-yaml':configRaw,constraints:constraints,'num-units':numUnits};if(series){params.series=series;}this._send_rpc({type:'Application',request:'Deploy',params:{applications:[params]}},handler);},setMetricCredentials:function setMetricCredentials(applicationName,macaroon,callback){var handler=function(userCallback,data){if(!userCallback){console.log('data returned by SetMetricCredentials API call:',data);return;}userCallback(data.error||null);}.bind(this,callback);this._send_rpc({type:'Application',request:'SetMetricCredentials',params:{creds:[{application:applicationName,'metrics-credentials':macaroon}]}},handler);},addMachines:function addMachines(params,callback,options){var ecs=this.get('ecs');var args=ecs._getArgs(arguments);if(options&&options.immediate){return this._addMachines.apply(this,args);}else{return ecs.lazyAddMachines(args,options);}},_addMachines:function _addMachines(params,callback){var self=this;if(!params.length){console.log('addMachines called without machines to add');return;}var intermediateCallback=null;if(callback){intermediateCallback=self._handleAddMachines.bind(self,callback);}var machineParams=params.map(function(param){var machineParam={jobs:param.jobs||[machineJobs.HOST_UNITS],series:param.series,'parent-id':param.parentId,'container-type':param.containerType};if(param.constraints){machineParam.constraints=self.prepareConstraints(param.constraints);}return machineParam;});var request={type:'Client',request:'AddMachines',params:{params:machineParams}};self._send_rpc(request,intermediateCallback);},_handleAddMachines:function _handleAddMachines(userCallback,data){var machines=data.response.machines||[];var transformedData={err:data.error,machines:machines.map(function(machine){var error=null;var machineError=machine.error;if(machineError){error=machineError.message;if(machineError.code){error+=' (code '+machineError.code+')';}}return{err:error,name:machine.machine};})};userCallback(transformedData);},destroyMachines:function destroyMachines(names,force,callback,options){var ecs=this.get('ecs');var args=ecs._getArgs(arguments);if(options&&options.immediate){return this._destroyMachines.apply(this,args);}else{return ecs._lazyDestroyMachines(args,options);}},_destroyMachines:function _destroyMachines(names,force,callback){if(!names.length){console.log('destroyMachines called without machines to remove');return;}var intermediateCallback=null;if(callback){intermediateCallback=this._handleDestroyMachines.bind(this,callback,names);}var request={type:'Client',request:'DestroyMachines',params:{'machine-names':names,force:!!force}};this._send_rpc(request,intermediateCallback);},_handleDestroyMachines:function _handleDestroyMachines(userCallback,names,data){var transformedData={err:data.error,names:names};userCallback(transformedData);},updateApplication:function updateApplication(applicationName,args,callback){var handler=function(userCallback,applicationName,args,data){if(!userCallback){console.log('data returned by application update API call:',data);return;}var response={applicationName:applicationName,err:data.error};Object.keys(args).forEach(function(key){response[key]=args[key];});userCallback(response);}.bind(this,callback,applicationName,args);var params={application:applicationName};if(args.url){params['charm-url']=args.url;params['force-charm-url']=!!args.forceUnits;params['force-series']=!!args.forceSeries;}if(args.settings){params.settings=stringifyObjectValues(args.settings);}if(args.constraints){params.constraints=this.prepareConstraints(args.constraints);}if(args.minUnits){params['min-units']=args.minUnits;}this._send_rpc({type:'Application',request:'Update',params:params},handler);},setCharm:function setCharm(applicationName,url,forceUnits,forceSeries,callback){var args={url:url,forceUnits:forceUnits,forceSeries:forceSeries};this.updateApplication(applicationName,args,function(data){if(!callback){return;}callback({err:data.err,applicationName:data.applicationName,charmUrl:data.url});});},add_unit:function add_unit(applicationName,numUnits,toMachine,callback,options){var ecs=this.get('ecs');var args=ecs._getArgs(arguments);if(options&&options.immediate){this._add_unit.apply(this,args);}else{ecs.lazyAddUnits(args,options);}},_add_unit:function _add_unit(applicationName,numUnits,toMachine,callback){var handleAddUnit=function(userCallback,data){if(!userCallback){console.log('data returned by addUnit API call:',data);return;}var transformedData={err:data.error,applicationName:applicationName};if(data.error){transformedData.numUnits=numUnits;}else{var units=data.response.units;transformedData.result=units;transformedData.numUnits=units.length;}userCallback(transformedData);}.bind(this,callback);this._send_rpc({type:'Application',request:'AddUnits',params:{application:applicationName,'num-units':numUnits,placement:[parsePlacement(toMachine)]}},handleAddUnit);},placeUnit:function placeUnit(unit,machineId){return this.get('ecs').placeUnit(unit,machineId);},remove_units:function remove_units(unitNames,callback,options){var ecs=this.get('ecs'),args=ecs._getArgs(arguments);if(options&&options.immediate){this._remove_units.apply(this,args);}else{ecs._lazyRemoveUnit(args);}},_remove_units:function _remove_units(unitNames,callback){var handleRemoveUnits=function(userCallback,unitNames,data){if(!userCallback){console.log('data returned by DestroyUnits API call:',data);return;}userCallback({err:data.error,unit_names:unitNames});}.bind(this,callback,unitNames);this._send_rpc({type:'Application',request:'DestroyUnits',params:{'unit-names':unitNames}},handleRemoveUnits);},expose:function expose(applicationName,callback,options){var ecs=this.get('ecs'),args=ecs._getArgs(arguments);if(options.immediate){this._expose.apply(this,args);}else{ecs.lazyExpose(args);}},_expose:function _expose(applicationName,callback){var intermediateCallback;if(callback){intermediateCallback=this.handleSimpleApplicationCalls.bind(null,callback,applicationName);}this._send_rpc({type:'Application',request:'Expose',params:{application:applicationName}},intermediateCallback);},unexpose:function unexpose(applicationName,callback,options){var ecs=this.get('ecs'),args=ecs._getArgs(arguments);if(options.immediate){this._unexpose.apply(this,args);}else{ecs.lazyUnexpose(args);}},_unexpose:function _unexpose(applicationName,callback){var intermediateCallback;if(callback){intermediateCallback=this.handleSimpleApplicationCalls.bind(null,callback,applicationName);}this._send_rpc({type:'Application',request:'Unexpose',params:{application:applicationName}},intermediateCallback);},handleSimpleApplicationCalls:function handleSimpleApplicationCalls(callback,applicationName,data){callback({err:data.error,applicationName:applicationName});},update_annotations:function update_annotations(entity,type,data,callback){var handler=function(userCallback,entity,data){if(!userCallback){return;}var response={entity:entity};if(data.error){response.err=data.error;userCallback(response);return;}var result=data.response.results[0];if(result.error){response.err=result.error;}userCallback(response);}.bind(this,callback,entity);this._send_rpc({type:'Annotations',request:'Set',params:{annotations:[{entity:this.generateTag(entity,type),annotations:stringifyObjectValues(data)}]}},handler);},remove_annotations:function remove_annotations(entity,type,keys,callback){var data=keys.reduce(function(collected,key){collected[key]='';return collected;},{});this.update_annotations(entity,type,data,callback);},get_annotations:function get_annotations(entity,type,callback){var handler=function(userCallback,entity,data){if(!userCallback){console.log('data returned by Annotations.Get API call:',data);return;}var response={entity:entity};if(data.error){response.err=data.error;userCallback(response);return;}var result=data.response.results[0];if(result.error){response.err=result.error;userCallback(response);return;}response.results=result.annotations;userCallback(response);}.bind(this,callback,entity);this._send_rpc({type:'Annotations',request:'Get',params:{entities:[{tag:this.generateTag(entity,type)}]}},handler);},generateTag:function generateTag(entity,type){return type+'-'+entity;},getApplicationConfig:function getApplicationConfig(applicationName,callback){var intermediateCallback;if(callback){intermediateCallback=this._handleGetApplicationConfig.bind(null,callback,applicationName);}this._send_rpc({type:'Application',request:'Get',params:{application:applicationName}},intermediateCallback);},_handleGetApplicationConfig:function _handleGetApplicationConfig(callback,applicationName,data){var config=(data.response||{}).config;var transformedConfig={};Y.each(config,function(value,key){transformedConfig[key]=value.value;});callback({err:data.error,applicationName:applicationName,result:{config:transformedConfig,constraints:(data.response||{}).constraints,series:(data.response||{}).series}});},set_config:function set_config(applicationName,config,callback,options){var ecs=this.get('ecs');var args=ecs._getArgs(arguments);if(options&&options.immediate){if(ecs.changeSet[applicationName]){throw'You cannot immediately set config on a queued application';}else{this._set_config.apply(this,args);}}else{ecs._lazySetConfig(args);}},_set_config:function _set_config(applicationName,config,callback){var args={settings:config};this.updateApplication(applicationName,args,function(data){if(!callback){return;}callback({err:data.err,applicationName:applicationName,newValues:config});});},destroyApplication:function destroyApplication(applicationName,callback,options){var ecs=this.get('ecs');var args=ecs._getArgs(arguments);if(options&&options.immediate){this._destroyApplication.apply(this,args);}else{ecs.lazyDestroyApplication(args);}},_destroyApplication:function _destroyApplication(applicationName,callback){var intermediateCallback;if(callback){intermediateCallback=this.handleSimpleApplicationCalls.bind(null,callback,applicationName);}this._send_rpc({type:'Application',request:'Destroy',params:{application:applicationName}},intermediateCallback);},resolved:function resolved(unitName,relationName,retry,callback){if(typeof unitName!=='string'){console.error('unitName must be a string value to resolve.');}var intermediateCallback;if(callback){intermediateCallback=this.handleResolved.bind(null,callback,unitName);}this._send_rpc({type:'Client',request:'Resolved',params:{'unit-name':unitName,retry:!!retry}},intermediateCallback);},handleResolved:function handleResolved(userCallback,unitName,data){userCallback({op:'resolved',err:data.error,unit_name:unitName});},add_relation:function add_relation(endpointA,endpointB,callback,options){var ecs=this.get('ecs'),args=ecs._getArgs(arguments);if(options&&options.immediate){this._add_relation.apply(this,args);}else{ecs._lazyAddRelation(args,options);}},_add_relation:function _add_relation(endpointA,endpointB,callback){var epA=endpointToName(endpointA);var epB=endpointToName(endpointB);var handleAddRelation=function(userCallback,epA,epB,data){if(!userCallback){console.log('data returned by AddRelation API call:',data);return;}var result={};var response=data.response;if(response&&response.endpoints){var endpoints=response.endpoints;var applicationNameA=epA.split(':')[0];var applicationNameB=epB.split(':')[0];result.endpoints=[];Y.each([applicationNameA,applicationNameB],function(name){var jujuEndpoint=endpoints[name];var guiEndpoint={};guiEndpoint[name]={'name':jujuEndpoint.name};result.endpoints.push(guiEndpoint);});result.id=createRelationKey(endpoints);result['interface']=endpoints[applicationNameA].interface;result.scope=endpoints[applicationNameA].scope;}userCallback({request_id:data['request-id'],endpoint_a:epA,endpoint_b:epB,err:data.error,result:result});}.bind(this,callback,epA,epB);this._send_rpc({type:'Application',request:'AddRelation',params:{endpoints:[epA,epB]}},handleAddRelation);},remove_relation:function remove_relation(endpointA,endpointB,callback,options){var ecs=this.get('ecs'),args=ecs._getArgs(arguments);if(options&&options.immediate){this._remove_relation.apply(this,args);}else{ecs._lazyRemoveRelation(args);}},_remove_relation:function _remove_relation(endpointA,endpointB,callback){var epA=endpointToName(endpointA);var epB=endpointToName(endpointB);var handleRemoveRelation=function(userCallback,epA,epB,data){if(!userCallback){console.log('data returned by DestroyRelation API call:',data);return;}userCallback({err:data.error,endpoint_a:epA,endpoint_b:epB});}.bind(this,callback,epA,epB);this._send_rpc({type:'Application',request:'DestroyRelation',params:{endpoints:[epA,epB]}},handleRemoveRelation);},get_charm:function get_charm(charmURL,callback){var handleRelations=function handleRelations(relations){relations=relations||{};return Object.keys(relations).reduce(function(prev,curr){var values=relations[curr];prev[curr]={interface:values.interface,name:values.name,role:values.role,scope:values.scope,limit:values.limit,optional:values.optional};return prev;},{});};var handler=function(userCallback,data){if(!userCallback){console.log('data returned by CharmInfo API call:',data);return;}if(data.error){userCallback({err:data.error});return;}var response=data.response;var config=response.config||{};var options=Object.keys(config).reduce(function(prev,curr){var values=config[curr];prev[curr]={type:values.type,description:values.description,default:values.default};return prev;},{});var meta=response.meta;var result={config:{options:options},peers:handleRelations(meta.peers),provides:handleRelations(meta.provides),requires:handleRelations(meta.requires),url:response.url,revision:response.revision,description:meta.description,minJujuVersion:meta['min-juju-version'],name:meta.name,subordinate:meta.subordinate,summary:meta.summary,tags:meta.tags||[],series:meta.series||[],terms:meta.terms||[],metrics:response.metrics};userCallback({result:result});}.bind(this,callback);this._send_rpc({type:'Charms',request:'CharmInfo',params:{'url':charmURL}},handler);},getBundleChanges:function getBundleChanges(bundleYAML,changesToken,callback){var handle=function handle(userCallback,data){if(!userCallback){console.log('data returned by Client.GetBundleChanges:',data);return;}userCallback({errors:data.error&&[data.error]||data.response.errors,changes:data.response&&data.response.changes});};this._send_rpc({type:'Client',request:'GetBundleChanges',params:{yaml:bundleYAML}},handle.bind(this,callback));},offer:function offer(applicationName,endpoints,url,users,description,callback){if(!url){var user=this.getCredentials().user.replace(/^user-/,'');var envName=this.get('environmentName');url='local:/u/'+user+'/'+envName+'/'+applicationName;}var handleOffer=function(userCallback,applicationName,endpoints,url,data){if(!userCallback){console.log('data returned by offer API call:',data);return;}var err=data.error;if(!err){var errResponse=data.response.results[0].error;err=errResponse&&errResponse.message;}userCallback({err:err,applicationName:applicationName,endpoints:endpoints,url:url});}.bind(this,callback,applicationName,endpoints,url);if(users&&users.length){users=users.map(function(user){return'user-'+user;});}else{users=['user-public'];}var offer={applicationname:applicationName,endpoints:endpoints,applicationurl:url,allowedusers:users,applicationdescription:description};this._send_rpc({type:'CrossModelRelations',request:'Offer',params:{offers:[offer]}},handleOffer);},listOffers:function listOffers(filters,callback){var handleListOffers=function(userCallback,data){if(!userCallback){console.log('data returned by listOffers API call:',data);return;}if(data.error){userCallback({err:data.error,results:[]});return;}var apiResults=data.response.results[0].result;var results=apiResults.map(function(apiResult){if(apiResult.error){return{err:apiResult.error};}var result=apiResult.result;return{applicationName:result.applicationname,url:result.applicationurl,charm:result.charmname,endpoints:result.endpoints.map(function(endpoint){return{name:endpoint.name,interface:endpoint.interface,role:endpoint.role};})};});userCallback({results:results});}.bind(this,callback);var filter={'filter-terms':[]};this._send_rpc({type:'CrossModelRelations',request:'ListOffers',params:{filters:[filter]}},handleListOffers);},getOffer:function getOffer(url,callback){var handleGetOffer=function(userCallback,data){if(!userCallback){console.log('data returned by getOffer API call:',data);return;}var err=data.error,response={};if(!err){response=data.response.results[0];err=response.error&&response.error.message;}if(err){userCallback({err:err});return;}var result=response.result;userCallback({applicationName:result.applicationname,url:result.applicationurl,description:result.applicationdescription,sourceName:result.sourcelabel,sourceId:result.sourceenviron.replace(/^environment-/,''),endpoints:result.endpoints.map(function(endpoint){return{name:endpoint.name,interface:endpoint.interface,role:endpoint.role};})});}.bind(this,callback);this._send_rpc({type:'CrossModelRelations',request:'ApplicationOffers',params:{applicationurls:[url]}},handleGetOffer);},createModel:function createModel(name,userTag,callback){var handler=function(userCallback,data){if(!userCallback){console.log('data returned by CreateModel API call:',data);return;}if(data.error){userCallback({err:data.error});return;}var response=data.response;userCallback({name:response.name,uuid:response.uuid,owner:response['owner-tag'],region:response['cloud-region']});}.bind(this,callback);if(userTag.indexOf('@')===-1){userTag+='@local';}var config={'authorized-keys':'ssh-rsa INVALID (set by the Juju GUI)'};this._send_rpc({type:'ModelManager',request:'CreateModel',params:{name:name,'owner-tag':userTag,config:config}},handler);},destroyModel:function destroyModel(callback){var handler=function(userCallback,data){if(!userCallback){console.log('data returned by destroy model API call:',data);return;}userCallback(data.error||null);}.bind(this,callback);this._send_rpc({type:'Client',request:'DestroyModel'},handler);},listModels:function listModels(userTag,callback){var handleListModels=function(userCallback,data){if(!userCallback){console.log('data returned by listModels API call:',data);return;}var transformedData={err:data.error};if(!data.error){var response=data.response;transformedData.envs=response['user-models'].map(function(value){var model=value.model;return{name:model.name,owner:model['owner-tag'],tag:'model-'+model.uuid,uuid:model.uuid,lastConnection:value['last-connection']};});}userCallback(transformedData);}.bind(this,callback);this._send_rpc({type:'ModelManager',request:'ListModels',params:{tag:userTag}},handleListModels);}});environments.endpointToName=endpointToName;environments.createRelationKey=createRelationKey;environments.GoEnvironment=GoEnvironment;environments.lowerObjectKeys=lowerObjectKeys;environments.parsePlacement=parsePlacement;environments.stringifyObjectValues=stringifyObjectValues;environments.machineJobs=machineJobs;var KVM={label:'KVM',value:'kvm'},LXC={label:'LXC',value:'lxc'},LXD={label:'LXD',value:'lxd'};environments.providerFeatures={all:{supportedContainerTypes:[KVM,LXC,LXD]},azure:{supportedContainerTypes:[]},demonstration:{supportedContainerTypes:[KVM,LXC,LXD]},ec2:{supportedContainerTypes:[KVM,LXC,LXD]},joyent:{supportedContainerTypes:[KVM,LXC,LXD]},lxd:{supportedContainerTypes:[]},maas:{supportedContainerTypes:[KVM,LXC,LXD]},openstack:{supportedContainerTypes:[KVM,LXC,LXD]},manual:{supportedContainerTypes:[]}};},'0.1.0',{requires:['base','json-parse','json-stringify','juju-env-base','juju-view-utils']});