'use strict';YUI.add('juju-env-legacy-api',function(Y){var PING_INTERVAL=10;var ADMIN_FACADE_VERSION=0;var environments=Y.namespace('juju.environments');var utils=Y.namespace('juju.views.utils');var endpointToName=function endpointToName(endpoint){if(!endpoint[1].name){return endpoint[0];}return endpoint[0]+':'+endpoint[1].name;};var createRelationKey=function createRelationKey(endpoints){var roles=Object.create(null);Y.each(endpoints,function(value,key){roles[value.Role]=key+':'+value.Name;});return roles.requirer+' '+roles.provider;};var lowerObjectKeys=function lowerObjectKeys(obj){var newObj=Object.create(null);Y.each(obj,function(value,key){newObj[key.toLowerCase()]=value;});return newObj;};var MACHINE_SCOPE='#';var parsePlacement=function parsePlacement(toMachine){if(!toMachine){return null;}var parts=toMachine.split(':');if(parts.length===2){return{Scope:parts[0],Directive:parts[1]};}var part=parts[0];if(part===LXC.value||part===KVM.value){return{Scope:part,Directive:''};}return{Scope:MACHINE_SCOPE,Directive:part};};var stringifyObjectValues=function stringifyObjectValues(obj){var newObj=Object.create(null);Y.each(obj,function(value,key){if(value===null){newObj[key]=value;}else{newObj[key]=value+'';}});return newObj;};var machineJobs={HOST_UNITS:'JobHostUnits',MANAGE_ENVIRON:'JobManageEnviron'};function GoLegacyEnvironment(config){GoLegacyEnvironment.superclass.constructor.apply(this,arguments);}GoLegacyEnvironment.NAME='legacy-api-env';Y.extend(GoLegacyEnvironment,environments.BaseEnvironment,{genericConstraints:['cpu-power','cpu-cores','mem','arch','tags','root-disk'],integerConstraints:['cpu-power','cpu-cores','mem','root-disk'],series:Object.keys(utils.getSeriesList()),defaultFacades:{AllWatcher:[0],Client:[0],Pinger:[0],ChangeSet:[0],GUIToken:[0]},initializer:function initializer(){this.defaultUser='admin';this._allWatcherId=null;this._pinger=null;this.pendingLoginResponse=false;this.on('_rpc_response',this._handleRpcResponse);},dispatch_result:function dispatch_result(data){var tid=data.RequestId;if(tid in this._txn_callbacks){this._txn_callbacks[tid].call(this,data);delete this._txn_callbacks[tid];}},_send_rpc:function _send_rpc(op,callback){var facade=op.Type;var version=op.Version;if(facade!=='Admin'){version=this.findFacadeVersion(facade,version);}if(version===null){callback({Error:'operation not supported by API server: '+JSON.stringify(op)});return;}if(this.ws.readyState!==1){console.log('Websocket is not open, dropping request. '+'readyState: '+this.ws.readyState,msg);return;}op.Version=version;var tid=this._counter+=1;if(callback){this._txn_callbacks[tid]=callback;}op.RequestId=tid;if(!op.Params){op.Params={};}var msg=Y.JSON.stringify(op);this.ws.send(msg);},_watchAll:function _watchAll(){this._send_rpc({Type:'Client',Request:'WatchAll'},function(data){if(data.Error){console.log('aiiiiie!');}else{this._allWatcherId=data.Response.AllWatcherId;this._next();}});},_handleRpcResponse:function _handleRpcResponse(data){this._next();var deltas=[],cmp={serviceLegacyInfo:1,relationLegacyInfo:2,unitLegacyInfo:3,machineLegacyInfo:4,annotationLegacyInfo:5};data.Response.Deltas.forEach(function(delta){var kind=delta[0],operation=delta[1],entityInfo=delta[2];deltas.push([kind+'LegacyInfo',operation,entityInfo]);});deltas.sort(function(a,b){if(!cmp[a[0]]){return 1;}if(!cmp[b[0]]){return-1;}var scoreA=cmp[a[0]];var scoreB=cmp[b[0]];if(a[1]==='remove'){scoreA=-scoreA;}if(b[1]==='remove'){scoreB=-scoreB;}return scoreA-scoreB;});this.fire('delta',{data:{result:deltas}});},_next:function _next(){this._send_rpc({Type:'AllWatcher',Request:'Next',Id:this._allWatcherId,Params:{}},function(data){if(data.Error){console.log('aiiiiie!');}else{this.fire('_rpc_response',data);}});},_stopWatching:function _stopWatching(callback){var cb=function(){this._allWatcherId=null;callback();}.bind(this);this._send_rpc({Type:'AllWatcher',Request:'Stop',Id:this._allWatcherId,Params:{}},cb);},prepareConstraints:function prepareConstraints(constraints){if(typeof constraints==='string'){var constraintsObj={};constraints.trim().split(/\s+/).forEach(function(constraint){var constraintParts=constraint.trim().split('=');if(constraintParts.length!==2){console.error('Got unexpected malformed constraint',constraint);return;}constraintsObj[constraintParts[0].trim()]=constraintParts[1].trim();});constraints=constraintsObj;}var result=Object.create(null);Object.keys(constraints).forEach(function(key){var value;if(this.integerConstraints.indexOf(key)!==-1){value=parseInt(constraints[key],10);}else if(this.genericConstraints.indexOf(key)!==-1){value=(constraints[key]||'').trim();}if(value||value===0){result[key]=value;}},this);var tags=result.tags;if(tags){result.tags=tags.split(',').reduce(function(collected,value){var tag=value.trim().split(/\s+/).join('-');if(tag){collected.push(tag);}return collected;},[]);}return result;},handleLogin:function handleLogin(data,fromToken){fromToken=!!fromToken;this.pendingLoginResponse=false;this.userIsAuthenticated=!data.Error;if(this.userIsAuthenticated){var response=data.Response;if(response&&response.AuthTag&&response.Password){this.setCredentials({user:response.AuthTag,password:response.Password});}var facadeList=response.facades||response.Facades||[];var facades=facadeList.reduce(function(previous,current){previous[current.Name]=current.Versions;return previous;},{});this.set('facades',facades);this.environmentInfo();this._watchAll();if(!this._pinger){this._pinger=setInterval(this.ping.bind(this),PING_INTERVAL*1000);}this.failedAuthentication=this.failedTokenAuthentication=false;}else{this.setCredentials(null);this.failedAuthentication=!fromToken;this.failedTokenAuthentication=fromToken;}this.fire('login',{data:{result:this.userIsAuthenticated,error:data.Error||null,fromToken:fromToken}});},findFacadeVersion:function findFacadeVersion(name,version){var facades=this.get('facades')||{};var versions=facades[name]||this.defaultFacades[name]||[];if(!versions.length){return null;}if(version===undefined||version===null){return versions[versions.length-1];}if(versions.indexOf(version)>-1){return version;}return null;},handleTokenLogin:function handleTokenLogin(data){this.handleLogin(data,true);},login:function login(){if(this.userIsAuthenticated){this.fire('login',{data:{result:true}});return;}if(this.pendingLoginResponse){return;}var credentials=this.getCredentials();if(!credentials.user||!credentials.password){console.warn('attempted login without providing credentials');this.fire('login',{data:{result:false}});return;}var params={AuthTag:credentials.user,Password:credentials.password};this._send_rpc({Type:'Admin',Request:'Login',Params:params,Version:ADMIN_FACADE_VERSION},this.handleLogin);this.pendingLoginResponse=true;},loginWithMacaroon:function loginWithMacaroon(bakery,callback){if(this.pendingLoginResponse){return;}var cback=function(err,response){this.handleLogin({Error:err,Response:response});if(callback){callback(err);return;}if(err){console.warn('macaroon authentication failed:',err);return;}console.debug('macaroon authentication succeeded');}.bind(this);cback('macaroon auth requires Juju 2');},beforeClose:function beforeClose(callback){if(this._pinger){clearInterval(this._pinger);this._pinger=null;}this._stopWatching(callback);},ping:function ping(){this._send_rpc({Type:'Pinger',Request:'Ping'});},tokenLogin:function tokenLogin(token){if(this.userIsAuthenticated){this.fire('login',{data:{result:true}});return;}if(this.pendingLoginResponse){return;}this._send_rpc({Type:'GUIToken',Request:'Login',Params:{Token:token}},this.handleTokenLogin);},_handleEnvironmentInfo:function _handleEnvironmentInfo(data){var _this=this;if(data.Error){console.warn('Error retrieving model information.');return;}var response=data.Response;this.set('defaultSeries',response.DefaultSeries);this.set('providerType',response.ProviderType);this.set('environmentName',response.Name);if(response.ProviderType!=='maas'){this.set('maasServer',null);return;}this.environmentGet(function(data){if(data.err){console.warn('error calling ModelGet API: '+data.err);return;}_this.set('maasServer',data.config['maas-server']);});},environmentInfo:function environmentInfo(){var request='EnvironmentInfo';this._send_rpc({Type:'Client',Request:request},this._handleEnvironmentInfo);},environmentGet:function environmentGet(callback){var intermediateCallback;if(callback){intermediateCallback=this._handleEnvironmentGet.bind(null,callback);}var facade='Client';var request='EnvironmentGet';this._send_rpc({Type:facade,Request:request},intermediateCallback);},_handleEnvironmentGet:function _handleEnvironmentGet(callback,data){var transformedData={err:data.Error};if(!data.Error){transformedData.config=data.Response.Config;}callback(transformedData);},uploadLocalCharm:function uploadLocalCharm(file,series,progress,callback){if(!this.userIsAuthenticated){console.warn('Attempted upload files without providing credentials.');this.fire('login',{data:{result:false}});return;}var credentials=this.getCredentials();var path='/juju-core/charms?series='+series;var headers={'Content-Type':'application/zip'};var webHandler=this.get('webHandler');webHandler.sendPostRequest(path,headers,file,credentials.user,credentials.password,progress,callback);},getLocalCharmFileUrl:function getLocalCharmFileUrl(charmUrl,filename){var credentials=this.getCredentials();var path='/juju-core/charms?url='+charmUrl+'&file='+filename;var webHandler=this.get('webHandler');return webHandler.getUrl(path,credentials.user,credentials.password);},_jujuHttpGet:function _jujuHttpGet(path,progress,callback){var credentials=this.getCredentials();var webHandler=this.get('webHandler');var headers=Object.create(null);webHandler.sendGetRequest(path,headers,credentials.user,credentials.password,progress,callback);},listLocalCharmFiles:function listLocalCharmFiles(charmUrl,progress,callback){var path='/juju-core/charms?url='+charmUrl;this._jujuHttpGet(path,progress,callback);},getLocalCharmFileContents:function getLocalCharmFileContents(charmUrl,filename,progress,callback){var path='/juju-core/charms?url='+charmUrl+'&file='+filename;this._jujuHttpGet(path,progress,callback);},deployerStatus:function deployerStatus(callback){var intermediateCallback;if(callback){intermediateCallback=this._handleDeployerStatus.bind(this,callback);}this._send_rpc({Type:'Deployer',Request:'Status'},intermediateCallback);},_handleDeployerStatus:function _handleDeployerStatus(userCallback,data){var lastChanges=data.Response.LastChanges||[];var transformedData={err:data.Error,changes:lastChanges.map(function(change){return{deploymentId:change.DeploymentId,status:change.Status,time:change.Time,queue:change.Queue,err:change.Error};})};userCallback(transformedData);},deployerWatch:function deployerWatch(deploymentId,callback){var intermediateCallback;if(callback){intermediateCallback=this.handleDeployerWatch.bind(this,callback);}this._send_rpc({Type:'Deployer',Request:'Watch',Params:{DeploymentId:deploymentId}},intermediateCallback);},handleDeployerWatch:function handleDeployerWatch(userCallback,data){var transformedData={err:data.Error,WatchId:data.Response.WatcherId};userCallback(transformedData);},deployerNext:function deployerNext(watchId,callback){var intermediateCallback;if(callback){intermediateCallback=this.handleDeployerNext.bind(this,callback);}this._send_rpc({Type:'Deployer',Request:'Next',Params:{WatcherId:watchId}},intermediateCallback);},handleDeployerNext:function handleDeployerNext(userCallback,data){var transformedData={err:data.Error,Changes:data.Response.Changes};userCallback(transformedData);},addCharm:function addCharm(url,macaroon,callback,options){var ecs=this.get('ecs');var args=ecs._getArgs(arguments);if(options&&options.immediate){this._addCharm.apply(this,args);}else{ecs._lazyAddCharm(arguments);}},_addCharm:function _addCharm(url,macaroon,callback){var handleAddCharm=function(userCallback,url,data){if(!userCallback){console.log('data returned by addCharm API call:',data);return;}userCallback({err:data.Error,url:url});}.bind(this,callback,url);var request={Type:'Client',Request:'AddCharm',Params:{URL:url}};if(macaroon){request.Request='AddCharmWithAuthorization';request.Params.CharmStoreMacaroon=macaroon;}this._send_rpc(request,handleAddCharm);},deploy:function deploy(charmUrl,series,applicationName,config,configRaw,numUnits,constraints,toMachine,callback,options){var ecs=this.get('ecs');var args=ecs._getArgs(arguments);if(options&&options.immediate){this._deploy.apply(this,args);}else{ecs._lazyDeploy(arguments);}},_deploy:function _deploy(charmUrl,series,applicationName,config,configRaw,numUnits,constraints,toMachine,callback){var handler=function(userCallback,applicationName,charmUrl,data){if(!userCallback){console.log('data returned by deploy API call:',data);return;}userCallback({err:data.Error,applicationName:applicationName,charmUrl:charmUrl});}.bind(this,callback,applicationName,charmUrl);if(constraints){if(typeof constraints==='function'){console.error('Constraints need to be an object not a function');console.warn(constraints);}constraints=this.prepareConstraints(constraints);}else{constraints={};}var params={ServiceName:applicationName,Config:stringifyObjectValues(config),ConfigYAML:configRaw,Constraints:constraints,CharmUrl:charmUrl,NumUnits:numUnits,ToMachineSpec:toMachine};this._send_rpc({Type:'Client',Request:'ServiceDeploy',Params:params},handler);},addMachines:function addMachines(params,callback,options){var ecs=this.get('ecs');var args=ecs._getArgs(arguments);if(options&&options.immediate){return this._addMachines.apply(this,args);}else{return ecs.lazyAddMachines(args,options);}},_addMachines:function _addMachines(params,callback){var self=this;if(!params.length){console.log('addMachines called without machines to add');return;}var intermediateCallback=null;if(callback){intermediateCallback=self._handleAddMachines.bind(self,callback);}var machineParams=params.map(function(param){var machineParam={Jobs:param.jobs||[machineJobs.HOST_UNITS],Series:param.series,ParentId:param.parentId,ContainerType:param.containerType};if(param.constraints){machineParam.Constraints=self.prepareConstraints(param.constraints);}return machineParam;});var request={Type:'Client',Request:'AddMachines',Params:{MachineParams:machineParams}};self._send_rpc(request,intermediateCallback);},_handleAddMachines:function _handleAddMachines(userCallback,data){var machines=data.Response.Machines||[];var transformedData={err:data.Error,machines:machines.map(function(machine){var error=null;var machineError=machine.Error;if(machineError){error=machineError.Message;if(machineError.Code){error+=' (code '+machineError.Code+')';}}return{err:error,name:machine.Machine};})};userCallback(transformedData);},destroyMachines:function destroyMachines(names,force,callback,options){var ecs=this.get('ecs');var args=ecs._getArgs(arguments);if(options&&options.immediate){return this._destroyMachines.apply(this,args);}else{return ecs._lazyDestroyMachines(args,options);}},_destroyMachines:function _destroyMachines(names,force,callback){if(!names.length){console.log('destroyMachines called without machines to remove');return;}var intermediateCallback=null;if(callback){intermediateCallback=this._handleDestroyMachines.bind(this,callback,names);}var request={Type:'Client',Request:'DestroyMachines',Params:{MachineNames:names,Force:!!force}};this._send_rpc(request,intermediateCallback);},_handleDestroyMachines:function _handleDestroyMachines(userCallback,names,data){var transformedData={err:data.Error,names:names};userCallback(transformedData);},updateApplication:function updateApplication(applicationName,args,callback){var handler=function(userCallback,applicationName,args,data){if(!userCallback){console.log('data returned by application update API call:',data);return;}var response={applicationName:applicationName,err:data.Error};Object.keys(args).forEach(function(key){response[key]=args[key];});userCallback(response);}.bind(this,callback,applicationName,args);var params={};if(args.url){params.CharmUrl=args.url;var forceUnits=!!args.forceUnits;var forceSeries=!!args.forceSeries;params.ForceCharmUrl=forceUnits||forceSeries;}if(args.settings){params.SettingsStrings=stringifyObjectValues(args.settings);}if(args.constraints){params.Constraints=this.prepareConstraints(args.constraints);}if(args.minUnits){params.MinUnits=args.minUnits;}var request;params.ServiceName=applicationName;request={Type:'Client',Request:'ServiceUpdate',Params:params};this._send_rpc(request,handler);},setCharm:function setCharm(applicationName,url,forceUnits,forceSeries,callback){var args={url:url,forceUnits:forceUnits,forceSeries:forceSeries};this.updateApplication(applicationName,args,function(data){if(!callback){return;}callback({err:data.err,applicationName:data.applicationName,charmUrl:data.url});});},add_unit:function add_unit(applicationName,numUnits,toMachine,callback,options){var ecs=this.get('ecs');var args=ecs._getArgs(arguments);if(options&&options.immediate){this._add_unit.apply(this,args);}else{ecs.lazyAddUnits(args,options);}},_add_unit:function _add_unit(applicationName,numUnits,toMachine,callback){var handleAddUnit=function(userCallback,data){if(!userCallback){console.log('data returned by addUnit API call:',data);return;}var transformedData={err:data.Error,applicationName:applicationName};if(data.Error){transformedData.numUnits=numUnits;}else{var units=data.Response.Units;transformedData.result=units;transformedData.numUnits=units.length;}userCallback(transformedData);}.bind(this,callback);this._send_rpc({Type:'Client',Request:'AddServiceUnits',Params:{ServiceName:applicationName,NumUnits:numUnits,ToMachineSpec:toMachine}},handleAddUnit);},placeUnit:function placeUnit(unit,machineId){return this.get('ecs').placeUnit(unit,machineId);},remove_units:function remove_units(unitNames,callback,options){var ecs=this.get('ecs'),args=ecs._getArgs(arguments);if(options&&options.immediate){this._remove_units.apply(this,args);}else{ecs._lazyRemoveUnit(args);}},_remove_units:function _remove_units(unitNames,callback){var handleRemoveUnits=function(userCallback,unitNames,data){if(!userCallback){console.log('data returned by DestroyUnits API call:',data);return;}userCallback({err:data.Error,unit_names:unitNames});}.bind(this,callback,unitNames);this._send_rpc({Type:'Client',Request:'DestroyServiceUnits',Params:{UnitNames:unitNames}},handleRemoveUnits);},expose:function expose(applicationName,callback,options){var ecs=this.get('ecs'),args=ecs._getArgs(arguments);if(options.immediate){this._expose.apply(this,args);}else{ecs.lazyExpose(args);}},_expose:function _expose(applicationName,callback){var intermediateCallback;if(callback){intermediateCallback=this.handleSimpleApplicationCalls.bind(null,callback,applicationName);}this._send_rpc({Type:'Client',Request:'ServiceExpose',Params:{ServiceName:applicationName}},intermediateCallback);},unexpose:function unexpose(applicationName,callback,options){var ecs=this.get('ecs'),args=ecs._getArgs(arguments);if(options.immediate){this._unexpose.apply(this,args);}else{ecs.lazyUnexpose(args);}},_unexpose:function _unexpose(applicationName,callback){var intermediateCallback;if(callback){intermediateCallback=this.handleSimpleApplicationCalls.bind(null,callback,applicationName);}this._send_rpc({Type:'Client',Request:'ServiceUnexpose',Params:{ServiceName:applicationName}},intermediateCallback);},handleSimpleApplicationCalls:function handleSimpleApplicationCalls(callback,applicationName,data){callback({err:data.Error,applicationName:applicationName});},update_annotations:function update_annotations(entity,type,data,callback){var handler=function(userCallback,entity,data){if(!userCallback){return;}var response={entity:entity};if(data.Error){response.err=data.Error;userCallback(response);return;}userCallback(response);}.bind(this,callback,entity);var tag=this.generateTag(entity,type);data=stringifyObjectValues(data);this._send_rpc({Type:'Client',Request:'SetAnnotations',Params:{Tag:tag,Pairs:data}},handler);},remove_annotations:function remove_annotations(entity,type,keys,callback){var data=keys.reduce(function(collected,key){collected[key]='';return collected;},{});this.update_annotations(entity,type,data,callback);},get_annotations:function get_annotations(entity,type,callback){var handler;var tag=this.generateTag(entity,type);handler=function(userCallback,entity,data){if(!userCallback){console.log('data returned by GetAnnotations API call:',data);return;}userCallback({err:data.Error,entity:entity,results:data.Response&&data.Response.Annotations});}.bind(this,callback,entity);this._send_rpc({Type:'Client',Request:'GetAnnotations',Params:{Tag:tag}},handler);},generateTag:function generateTag(entity,type){if(type==='application'){type='service';}if(type==='model'){type='environment';}return type+'-'+entity;},getApplicationConfig:function getApplicationConfig(applicationName,callback){var intermediateCallback;if(callback){intermediateCallback=this._handleGetApplicationConfig.bind(null,callback,applicationName);}this._send_rpc({Type:'Client',Request:'ServiceGet',Params:{ServiceName:applicationName}},intermediateCallback);},_handleGetApplicationConfig:function _handleGetApplicationConfig(callback,applicationName,data){var config=(data.Response||{}).Config;var transformedConfig={};Y.each(config,function(value,key){transformedConfig[key]=value.value;});callback({err:data.Error,applicationName:applicationName,result:{config:transformedConfig,constraints:(data.Response||{}).Constraints}});},set_config:function set_config(applicationName,config,callback,options){var ecs=this.get('ecs');var args=ecs._getArgs(arguments);if(options&&options.immediate){if(ecs.changeSet[applicationName]){throw'You cannot immediately set config on a queued application';}else{this._set_config.apply(this,args);}}else{ecs._lazySetConfig(args);}},_set_config:function _set_config(applicationName,config,callback){var args={settings:config};this.updateApplication(applicationName,args,function(data){if(!callback){return;}callback({err:data.err,applicationName:applicationName,newValues:config});});},destroyApplication:function destroyApplication(applicationName,callback,options){var ecs=this.get('ecs');var args=ecs._getArgs(arguments);if(options&&options.immediate){this._destroyApplication.apply(this,args);}else{ecs.lazyDestroyApplication(args);}},_destroyApplication:function _destroyApplication(applicationName,callback){var intermediateCallback;if(callback){intermediateCallback=this.handleSimpleApplicationCalls.bind(null,callback,applicationName);}this._send_rpc({Type:'Client',Request:'ServiceDestroy',Params:{ServiceName:applicationName}},intermediateCallback);},resolved:function resolved(unitName,relationName,retry,callback){if(typeof unitName!=='string'){console.error('unitName must be a string value to resolve.');}var intermediateCallback,sendData;if(callback){intermediateCallback=this.handleResolved.bind(null,callback,unitName);}sendData={Type:'Client',Request:'Resolved',Params:{UnitName:unitName,Retry:!!retry}};this._send_rpc(sendData,intermediateCallback);},handleResolved:function handleResolved(userCallback,unitName,data){userCallback({op:'resolved',err:data.Error,unit_name:unitName});},add_relation:function add_relation(endpointA,endpointB,callback,options){var ecs=this.get('ecs'),args=ecs._getArgs(arguments);if(options&&options.immediate){this._add_relation.apply(this,args);}else{ecs._lazyAddRelation(args,options);}},_add_relation:function _add_relation(endpointA,endpointB,callback){var epA=endpointToName(endpointA);var epB=endpointToName(endpointB);var handleAddRelation=function(userCallback,epA,epB,data){if(!userCallback){console.log('data returned by AddRelation API call:',data);return;}var result={};var response=data.Response;if(response&&response.Endpoints){var applicationNameA=epA.split(':')[0];var applicationNameB=epB.split(':')[0];result.endpoints=[];Y.each([applicationNameA,applicationNameB],function(name){var jujuEndpoint=response.Endpoints[name];var guiEndpoint={};guiEndpoint[name]={'name':jujuEndpoint.Name};result.endpoints.push(guiEndpoint);});result.id=createRelationKey(response.Endpoints);result['interface']=response.Endpoints[applicationNameA].Interface;result.scope=response.Endpoints[applicationNameA].Scope;}userCallback({request_id:data.RequestId,endpoint_a:epA,endpoint_b:epB,err:data.Error,result:result});}.bind(this,callback,epA,epB);var request={Type:'Client',Request:'AddRelation',Params:{Endpoints:[epA,epB]}};this._send_rpc(request,handleAddRelation);},remove_relation:function remove_relation(endpointA,endpointB,callback,options){var ecs=this.get('ecs'),args=ecs._getArgs(arguments);if(options&&options.immediate){this._remove_relation.apply(this,args);}else{ecs._lazyRemoveRelation(args);}},_remove_relation:function _remove_relation(endpointA,endpointB,callback){var epA=endpointToName(endpointA);var epB=endpointToName(endpointB);var handleRemoveRelation=function(userCallback,epA,epB,data){if(!userCallback){console.log('data returned by DestroyRelation API call:',data);return;}userCallback({err:data.Error,endpoint_a:epA,endpoint_b:epB});}.bind(this,callback,epA,epB);var request={Type:'Client',Request:'DestroyRelation',Params:{Endpoints:[epA,epB]}};this._send_rpc(request,handleRemoveRelation);},get_charm:function get_charm(charmURL,callback){var intermediateCallback;if(callback){intermediateCallback=this.handleCharmInfo.bind(null,callback);}this._send_rpc({Type:'Client',Request:'CharmInfo',Params:{CharmURL:charmURL}},intermediateCallback);},handleCharmInfo:function handleCharmInfo(userCallback,data){var parseItems=function parseItems(items){var result={};Y.each(items,function(value,key){result[key]=lowerObjectKeys(value);});return result;};var result,response=data.Response;if(!Y.Object.isEmpty(response)){var meta=response.Meta;result={config:{options:parseItems(response.Config.Options)},peers:parseItems(meta.Peers),provides:parseItems(meta.Provides),requires:parseItems(meta.Requires),url:response.URL,revision:response.Revision,description:meta.Description,format:meta.Format,name:meta.Name,subordinate:meta.Subordinate,summary:meta.Summary};}var transformedData={err:data.Error,result:result};userCallback(transformedData);},getBundleChanges:function getBundleChanges(bundleYAML,changesToken,callback){var intermediateCallback=this.handleGetBundleChanges.bind(null,callback);var params=Object.create(null);if(bundleYAML!==null){params.YAML=bundleYAML;}else{params.Token=changesToken;}this._send_rpc({Type:'ChangeSet',Request:'GetChanges',Params:params},intermediateCallback);},handleGetBundleChanges:function handleGetBundleChanges(callback,data){if(!callback){console.log('data returned by ChangeSet.GetChanges:',data);return;}callback({errors:data.Error&&[data.Error]||data.Response&&data.Response.Errors,changes:data.Response&&data.Response.Changes});},createModel:function createModel(name,userTag,callback){var _this2=this;var intermediateCallback;if(callback){intermediateCallback=this._handleCreateModel.bind(null,callback);}else{intermediateCallback=function intermediateCallback(callback,data){console.log('createModel done: err:',data.Error);};}var facade='EnvironmentManager';var request='CreateEnvironment';this._send_rpc({Type:facade,Request:'ConfigSkeleton'},function(data){if(data.Error){intermediateCallback({Error:'cannot get configuration skeleton: '+data.Error});return;};var config=data.Response.Config;_this2.environmentGet(function(data){if(data.err){intermediateCallback({Error:'cannot get model configuration: '+data.err});return;}config.name=name;config['authorized-keys']='ssh-rsa INVALID';Object.keys(data.config).forEach(function(attr){if(attr!=='uuid'&&config[attr]===undefined){config[attr]=data.config[attr];}});_this2._send_rpc({Type:facade,Request:request,Params:{OwnerTag:userTag,Config:config}},intermediateCallback);});});},_handleCreateModel:function _handleCreateModel(callback,data){var transformedData={err:data.Error};if(!data.Error){var response=data.Response;transformedData.name=response.Name;transformedData.owner=response.OwnerTag;transformedData.uuid=response.UUID;}callback(transformedData);},destroyModel:function destroyModel(callback){var handler=function(userCallback,data){if(!userCallback){console.log('data returned by destroy model API call:',data);return;}userCallback(data.Error||null);}.bind(this,callback);this._send_rpc({Type:'Client',Request:'DestroyModel'},handler);},listModels:function listModels(userTag,callback){var facade='EnvironmentManager';var request='ListEnvironments';var results='UserEnvironments';var handleListModels=function(userCallback,data){if(!userCallback){console.log('data returned by listModels API call:',data);return;}var transformedData={err:data.Error};if(!data.Error){var response=data.Response;transformedData.envs=response[results].map(function(value){return{name:value.Name,tag:'model-'+value.UUID,owner:value.OwnerTag,uuid:value.UUID,lastConnection:value.LastConnection};});}userCallback(transformedData);}.bind(this,callback);this._send_rpc({Type:facade,Request:request,Params:{Tag:userTag}},handleListModels);},listModelsWithInfo:function listModelsWithInfo(callback){callback('not implemented',null);}});environments.legacyCreateRelationKey=createRelationKey;environments.GoLegacyEnvironment=GoLegacyEnvironment;environments.legacyParsePlacement=parsePlacement;var KVM={label:'KVM',value:'kvm'},LXC={label:'LXC',value:'lxc'};},'0.1.0',{requires:['base','json-parse','json-stringify','juju-env-base','juju-view-utils']});