'use strict';YUI.add('juju-view-utils',function(Y){var views=Y.namespace('juju.views'),utils=Y.namespace('juju.views.utils');utils.getSeriesList=function(){return{precise:{name:'Precise 12.04'},trusty:{name:'Trusty 14.04'},xenial:{name:'Xenial 16.04'},centos7:{name:'CentOS 7'},win2012hvr2:{name:'Windows Server 2012 R2 Hyper-V'},win2012hv:{name:'Windows Server 2012 Hyper-V'},win2012r2:{name:'Windows Server 2012 R2'},win2012:{name:'Windows Server 2012'}};};var generateHash=function generateHash(value){return value.split('').reduce(function(hash,character){hash=(hash<<5)-hash+character.charCodeAt(0);return hash&hash;},0);};utils.generateHash=generateHash;var generateSafeDOMId=function generateSafeDOMId(value,parentId){parentId=parentId||'';return'e-'+value.replace(/\W/g,'_')+'-'+generateHash(value+parentId);};utils.generateSafeDOMId=generateSafeDOMId;var timestrings={prefixAgo:null,prefixFromNow:null,suffixAgo:'ago',suffixFromNow:'from now',seconds:'less than a minute',minute:'about a minute',minutes:'%d minutes',hour:'about an hour',hours:'about %d hours',day:'a day',days:'%d days',month:'about a month',months:'%d months',year:'about a year',years:'%d years',wordSeparator:' ',numbers:[]};var humanizeNumber=function humanizeNumber(n){var units=[[1000,'K'],[1000000,'M'],[1000000000,'B']],result=n;Y.each(units,function(sizer){var threshold=sizer[0],unit=sizer[1];if(n>threshold){result=n/threshold;if(n%threshold!==0){result=result.toFixed(1);}result=result+unit;}});return result;};utils.humanizeNumber=humanizeNumber;var hasSVGClass=function hasSVGClass(selector,class_name){var classes=selector.getAttribute('class');if(!classes){return false;}return classes.indexOf(class_name)!==-1;};utils.hasSVGClass=hasSVGClass;var addSVGClass=function addSVGClass(selector,class_name){var self=this;if(!selector){return;}if(typeof selector==='string'){Y.all(selector).each(function(n){var classes=this.getAttribute('class');if(!self.hasSVGClass(this,class_name)){this.setAttribute('class',classes+' '+class_name);}});}else{var classes=selector.getAttribute('class');if(!self.hasSVGClass(selector,class_name)){selector.setAttribute('class',classes+' '+class_name);}}};utils.addSVGClass=addSVGClass;var removeSVGClass=function removeSVGClass(selector,class_name){if(!selector){return;}if(typeof selector==='string'){Y.all(selector).each(function(){var classes=this.getAttribute('class');this.setAttribute('class',classes.replace(class_name,''));});}else{var classes=selector.getAttribute('class');selector.setAttribute('class',classes.replace(class_name,''));}};utils.removeSVGClass=removeSVGClass;var consoleManager=function consoleManager(){var noop=function noop(){};var winConsole=window.console,consoleNoop={group:noop,groupEnd:noop,groupCollapsed:noop,time:noop,timeEnd:noop,log:noop,info:noop,error:noop,debug:noop,warn:noop};if(winConsole===undefined){window.console=consoleNoop;winConsole=consoleNoop;}return{native:function native(){window.console=winConsole;},noop:function noop(){window.console=consoleNoop;},console:function console(x){if(!arguments.length){return consoleNoop;}consoleNoop=x;return x;}};};utils.consoleManager=consoleManager;window.consoleManager=consoleManager();var humanizeTimestamp=function humanizeTimestamp(t){var l=timestrings,prefix=l.prefixAgo,suffix=l.suffixAgo,distanceMillis=Y.Lang.now()-t,seconds=Math.abs(distanceMillis)/1000,minutes=seconds/60,hours=minutes/60,days=hours/24,years=days/365;function substitute(stringOrFunction,number){var string=Y.Lang.isFunction(stringOrFunction)?stringOrFunction(number,distanceMillis):stringOrFunction,value=l.numbers&&l.numbers[number]||number;return string.replace(/%d/i,value);}var words=seconds<45&&substitute(l.seconds,Math.round(seconds))||seconds<90&&substitute(l.minute,1)||minutes<45&&substitute(l.minutes,Math.round(minutes))||minutes<90&&substitute(l.hour,1)||hours<24&&substitute(l.hours,Math.round(hours))||hours<42&&substitute(l.day,1)||days<30&&substitute(l.days,Math.round(days))||days<45&&substitute(l.month,1)||days<365&&substitute(l.months,Math.round(days/30))||years<1.5&&substitute(l.year,1)||substitute(l.years,Math.round(years));return Y.Lang.trim([prefix,words,suffix].join(' '));};views.humanizeTimestamp=humanizeTimestamp;var JujuBaseView=Y.Base.create('JujuBaseView',Y.Base,[],{bindModelView:function bindModelView(model){model=model||this.get('model');if(model){model.addTarget(this);}this.after('modelChange',function(ev){if(ev.prevVal){ev.prevVal.removeTarget(this);}if(ev.newVal){ev.newVal.addTarget(this);}this.render();});this.after(['*:change','*:load'],this.render,this);},renderable_charm:function renderable_charm(charm_name,db,getModelURL){var charm=db.charms.getById(charm_name);if(charm){var result=charm.getAttrs();result.app_url=getModelURL(charm);return result;}return null;}});views.JujuBaseView=JujuBaseView;views.createModalPanel=function(body_content,render_target,action_label,action_cb){var panel=new Y.Panel({bodyContent:body_content,width:400,zIndex:5,centered:true,show:false,classNames:'modal',modal:true,render:render_target,buttons:[]});if(action_label&&action_cb){views.setModalButtons(panel,action_label,action_cb);}return panel;};views.setModalButtons=function(panel,action_label,action_cb){panel.set('buttons',[]);panel.addButton({value:action_label,section:Y.WidgetStdMod.FOOTER,action:action_cb,classNames:['button']});panel.addButton({value:'Cancel',section:Y.WidgetStdMod.FOOTER,action:function action(e){e.preventDefault();panel.hide();},classNames:['button']});panel.get('boundingBox').all('.yui3-button').removeClass('yui3-button');return panel;};utils.isPythonRelation=function(relationId){var regex=/^relation-\d+$/;return regex.test(relationId);};utils.getRelationDataForService=function(db,application,withApplication){var relationsArray=db.relations.get_relations_for_service(application);if(withApplication!==undefined){var withApplicationName=withApplication.get('id');relationsArray=relationsArray.filter(function(relation){var rel=relation.getAttrs();if(rel.endpoints[0][0]===withApplicationName||rel.endpoints[1][0]===withApplicationName){return relation;}});}var applicationName=application.get('id');return relationsArray.map(function(relation){var rel=relation.getAttrs(),near,far;if(rel.endpoints[0][0]===applicationName){near=rel.endpoints[0];far=rel.endpoints[1];}else{near=rel.endpoints[1];far=rel.endpoints[0];}rel.near={service:near[0],serviceName:application.get('name'),role:near[1].role,name:near[1].name};var farService;if(far){var id=far[0];farService={service:id,serviceName:db.services.getById(id).get('name'),role:far[1].role,name:far[1].name};}rel.far=farService;var relationId=rel.relation_id;if(utils.isPythonRelation(relationId)){var relNumber=relationId.split('-')[1];rel.ident=near[1].name+':'+parseInt(relNumber,10);}else{rel.ident=relationId;}rel.elementId=generateSafeDOMId(rel.relation_id);return rel;});};utils.parseEndpointStrings=function(db,endpoints){return Y.Array.map(endpoints,function(endpoint){var epData=endpoint.split(':');var result={};if(epData.length>1){result.name=epData[0];result.type=epData[1];}else{result.name=epData[0];}result.service=db.services.getById(result.name);if(result.service){result.charm=db.charms.getById(result.service.get('charm'));if(!result.charm){console.warn('Failed to load charm',result.charm,db.charms.size(),db.charms.get('id'));}}else{console.warn('failed to resolve service',result.name);}return result;},this);};utils.findEndpointMatch=function(endpoints){var matches=[],result;Y.each([0,1],function(providedIndex){var providingEndpoint=endpoints[providedIndex];var provides=Y.merge(providingEndpoint.charm.get('provides')||{}),requiringEndpoint=endpoints[!providedIndex+0],requires=Y.merge(requiringEndpoint.charm.get('requires')||{});if(!provides['juju-info']){provides['juju-info']={'interface':'juju-info',scope:'container'};}var candidateProvideTypes,candidateRequireTypes;if(providingEndpoint.type){candidateProvideTypes=[providingEndpoint.type];}else{candidateProvideTypes=Y.Object.keys(provides);}if(requiringEndpoint.type){candidateRequireTypes=[requiringEndpoint.type];}else{candidateRequireTypes=Y.Object.keys(requires);}Y.each(candidateProvideTypes,function(provideType){Y.each(candidateRequireTypes,function(requireType){var provideMatch=provides[provideType],requireMatch=requires[requireType];if(provideMatch&&requireMatch&&provideMatch['interface']===requireMatch['interface']){matches.push({'interface':provideMatch['interface'],scope:provideMatch.scope||requireMatch.scope,provides:providingEndpoint,requires:requiringEndpoint,provideType:provideType,requireType:requireType});}});});});if(matches.length===0){console.log(endpoints);result={error:'Specified relation is unavailable.'};}else if(matches.length>1){var explicitRelations=matches.filter(function(rel){return rel['provideType']!=='juju-info';});if(explicitRelations.length===0){console.log(endpoints);result={error:'No explicitly specified relations are available.'};}else if(explicitRelations.length>1){result={error:'Ambiguous relationship is not allowed.'};}else{result=explicitRelations[0];}}else{result=matches[0];result.provides=Y.merge(result.provides);result.requires=Y.merge(result.requires);result.provides.type=result.provideType;result.requires.type=result.requireType;}return result;};utils.snapToPoles=false;utils.validate=function(values,schema){var errors={};function toString(value){if(value===null||value===undefined){return'';}return String(value).trim();}function isInt(value){return /^[-+]?[0-9]+$/.test(value);}function isFloat(value){return /^[-+]?[0-9]+\.?[0-9]*$|^[0-9]*\.?[0-9]+$/.test(value);}Y.Object.each(schema,function(field_definition,name){var value=toString(values[name]);if(field_definition.type==='int'){if(!value){if(field_definition['default']===undefined){errors[name]='This field is required.';}}else if(!isInt(value)){errors[name]='The value "'+value+'" is not an integer.';}}else if(field_definition.type==='float'){if(!value){if(field_definition['default']===undefined){errors[name]='This field is required.';}}else if(!isFloat(value)){errors[name]='The value "'+value+'" is not a float.';}}});return errors;};var _box={};function positionProp(name){return{get:function get(){return this['_'+name];},set:function set(value){this['p'+name]=this['_'+name];this['_'+name]=parseFloat(value);}};}Object.defineProperties(_box,{x:positionProp('x'),y:positionProp('y'),w:positionProp('w'),h:positionProp('h'),pos:{get:function get(){return{x:this.x,y:this.y,w:this.w,h:this.h};},set:function set(value){Y.mix(this,value,true,['x','y','w','h']);}},translateStr:{get:function get(){return'translate('+this.x+','+this.y+')';}},model:{get:function get(){if(!this._modelName){return null;}return this.topology.serviceForBox(this);},set:function set(value){if(Y.Lang.isValue(value)){Y.mix(this,value.getAttrs(),true);this._modelName=value.name;}}},modelId:{get:function get(){return this._modelName+'-'+this.id;}},node:{get:function get(){return this.module.getServiceNode(this.id);}},topology:{get:function get(){return this.module.get('component');}},xy:{get:function get(){return[this.x,this.y];}},wh:{get:function get(){return[this.w,this.h];}},margins:{get:function get(){if(!this.module){return{top:0,bottom:0,left:0,right:0};}if(this.subordinate){return this.module.subordinate_margins;}return this.module.service_margins;}},relativeCenter:{get:function get(){var margins=this.margins;return[this.w/2+(margins&&margins.left*this.w/2-margins.right*this.w/2||0),this.h/2-(margins&&margins.bottom*this.h/2-margins.top*this.h/2||0)];}},center:{get:function get(){var c=this.relativeCenter;c[0]+=this.x;c[1]+=this.y;return c;}},containsPoint:{writable:true,configurable:true,value:function value(point,transform){transform=transform||{translate:function translate(){return[0,0];},scale:function scale(){return 1;}};var tr=transform.translate(),s=transform.scale();return Math.pow((point[0]-tr[0])/s-(this.x+this.w/2),2)+Math.pow((point[1]-tr[1])/s-(this.y+this.w/2),2)<=Math.pow(this.w/2,2);}},connectors:{get:function get(){var margins=this.margins;if(utils.snapToPoles){return{top:[this.x+this.w/2,this.y+(margins&&margins.top*this.h||0)],right:[this.x+this.w-(margins&&margins.right*this.w||0),this.y+this.h/2-(margins&&margins.bottom*this.h/2-margins.top*this.h/2||0)],bottom:[this.x+this.w/2,this.y+this.h-(margins&&margins.bottom*this.h||0)],left:[this.x+(margins&&margins.left*this.w||0),this.y+this.h/2-(margins&&margins.bottom*this.h/2-margins.top*this.h/2||0)]};}else{return{center:[this.x+this.w/2,this.y+this.h/2]};}}},_distance:{value:function value(xy1,xy2){return Math.sqrt(Math.pow(xy1[0]-xy2[0],2)+Math.pow(xy1[1]-xy2[1],2));}},getNearestConnector:{value:function value(box_or_xy){var connectors=this.connectors,result=null,shortest_d=Infinity,source=box_or_xy;if(box_or_xy.xy!==undefined){source=box_or_xy.xy;}Y.each(connectors,function(ep){var d=this._distance(source,ep);if(!Y.Lang.isValue(result)||d<shortest_d){shortest_d=d;result=ep;}},this);return result;}},getConnectorPair:{value:function value(other_box){var sc=this.connectors,oc=other_box.connectors,result=null,shortest_d=Infinity;Y.each(sc,function(ep1){Y.each(oc,function(ep2){var d=this._distance(ep1,ep2);if(!Y.Lang.isValue(result)||d<shortest_d){shortest_d=d;result=[ep1,ep2];}},other_box);},this);return result;}}});function BoundingBox(module,model){var b=Object.create(_box);b.module=module;b.model=model;return b;}views.BoundingBox=BoundingBox;views.toBoundingBoxes=function(module,services,existing,env){var result=existing||{};Y.each(result,function(val,key,obj){if(!Y.Lang.isValue(services.getById(key))){delete result[key];}});services.each(function(service){var id=service.get('id');if(result[id]!==undefined){result[id].model=service;}else{result[id]=new BoundingBox(module,service);}if(!service.get('icon')&&service.get('charm')){var icon;var charmId=service.get('charm');icon=utils.getIconPath(charmId,null,env);service.set('icon',icon);}result[id].icon=service.get('icon');});return result;};views.DecoratedRelation=function(relation,source,target){var endpoints=relation.endpoints||relation.get('endpoints');var hasRelations=Y.Lang.isValue(endpoints);var decorated={source:source,target:target,sourceId:hasRelations?endpoints[0][0]+':'+endpoints[0][1].name:'',targetId:hasRelations?endpoints[1][0]+':'+endpoints[1][1].name:'',compositeId:source.modelId+(hasRelations?':'+endpoints[0][1].name:'')+'-'+target.modelId+(hasRelations?':'+endpoints[1][1].name:'')};decorated._endpointHasError=function(service){var endpoint=this.endpoints[0][0]===service.id?this.endpoints[0]:this.endpoints[1];return Y.Array.some(service.units.toArray(),function(unit){var relationName=endpoint[1].name+'-'+'relation',relationError=false,agentStateData=unit.agent_state_data,agentStateInfo=unit.agent_state_info;if(agentStateData&&agentStateData.hook){relationError=agentStateData.hook.indexOf(relationName)===0;}if(!relationError&&agentStateInfo){relationError=agentStateInfo.indexOf(relationName)>=0;}return unit.agent_state==='error'&&relationError;});};decorated.sourceHasError=function(){return this._endpointHasError(this.source);};decorated.targetHasError=function(){return this._endpointHasError(this.target);};decorated.hasRelationError=function(){return this.sourceHasError()||this.targetHasError();};Y.mix(decorated,relation.getAttrs());decorated.isSubordinate=utils.isSubordinateRelation(decorated);return decorated;};utils.isSubordinateRelation=function(relation){var source=relation.source,target=relation.target,subordinateModel=true;if(target&&source){subordinateModel=target.model.get('subordinate')||source.model.get('subordinate');}return subordinateModel&&relation.scope==='container';};var _relationCollection={};Object.defineProperties(_relationCollection,{aggregatedStatus:{get:function get(){var pending=Y.Array.some(this.relations,function(relation){return relation.pending;});if(pending){return'pending';}var unhealthy=Y.Array.some(this.relations,function(relation){return relation.hasRelationError();});var pendingDeletion=Y.Array.some(this.relations,function(relation){return relation.deleted;});if(unhealthy){return(pendingDeletion?'pending-':'')+'error';}if(this.isSubordinate){return'subordinate';}else{return(pendingDeletion?'pending-':'')+'healthy';}}},isSubordinate:{get:function get(){return Y.Array.every(this.relations,function(relation){return relation.isSubordinate;});}}});function RelationCollection(source,target,relations){var collection=Object.create(_relationCollection);collection.source=source;collection.target=target;collection.relations=relations;collection.id=relations[0].id;collection.compositeId=relations[0].id;return collection;}views.RelationCollection=RelationCollection;utils.toRelationCollections=function(relations){var collections={};relations.forEach(function(relation){var key=[relation.source.modelId,relation.target.modelId].sort().join();if(collections[key]){collections[key].relations.push(relation);}else{collections[key]=new RelationCollection(relation.source,relation.target,[relation]);}});return Y.Object.values(collections);};utils.simplifyState=function(unit,life){var state=unit.agent_state,inError=/-?error$/.test(state);if(!state){return'uncommitted';}if(life==='dying'&&!inError){return'dying';}else{if(state==='started'){return'running';}if(inError){return'error';}return state;}};utils.exportEnvironmentFile=function(db,legacyServicesKey){var result=db.exportDeployer(legacyServicesKey);var exportData=jsyaml.dump(result);var exportBlob=new Blob([exportData],{type:'text/plain;charset=utf-8'});var envName=db.environment.get('name');saveAs(exportBlob,this._genereateBundleExportFileName(envName));},utils._genereateBundleExportFileName=function(envName){var date=arguments.length<=1||arguments[1]===undefined?new Date():arguments[1];var fileExtension='.yaml';return[envName,date.getFullYear(),('0'+(date.getMonth()+1)).slice(-2),('0'+date.getDate()).slice(-2)].join('-')+fileExtension;},utils._onYAMLConfigLoaded=function(filename,callback,e){var config=jsyaml.safeLoad(e.target.result);callback(config);},utils.getYAMLConfig=function(file,callback){var reader=new FileReader();reader.onload=utils._onYAMLConfigLoaded.bind(utils,file.name,callback);reader.readAsText(file);},utils.determineCategoryType=function(category){if(/fail|error/.test(category)){return'error';}if(/landscape/.test(category)){return'landscape';}if(category==='running'){return'running';}if(category==='uncommitted'){return'uncommitted';}return'pending';};utils.ensureTrailingSlash=function(text){if(text.lastIndexOf('/')!==text.length-1){text+='/';}return text;};utils.getLandscapeURL=function(environment,serviceOrUnit,intent){var envAnnotations=environment.get('annotations');var url=envAnnotations['landscape-url'];if(!url){return undefined;}url+=envAnnotations['landscape-computers'];if(serviceOrUnit){var annotation;if(serviceOrUnit.name==='service'){annotation=serviceOrUnit.get('annotations')['landscape-computers'];if(!annotation){console.warn('Service missing the landscape-computers annotation!');return undefined;}url+=utils.ensureTrailingSlash(annotation);}else if(serviceOrUnit.name==='serviceUnit'){var serviceUnitAnnotation;if(serviceOrUnit.get){serviceUnitAnnotation=serviceOrUnit.get('annotations');}else{serviceUnitAnnotation=serviceOrUnit.annotations;}annotation=serviceUnitAnnotation&&serviceUnitAnnotation['landscape-computer'];if(!annotation){console.warn('Unit missing the landscape-computer annotation!');return undefined;}url+=utils.ensureTrailingSlash(annotation);}}if(!intent){return utils.ensureTrailingSlash(url);}else if(intent==='reboot'){return url+envAnnotations['landscape-reboot-alert-url'];}else if(intent==='security'){return url+envAnnotations['landscape-security-alert-url'];}};utils.getEffectiveViewportSize=function(primary,minwidth,minheight){var containerHeight=Y.one('body').get(primary?'winHeight':'docHeight'),bottomNavbar=Y.one('.bottom-navbar'),navbar=Y.one('.header-banner'),viewport=Y.one('#viewport'),result={height:minheight||0,width:minwidth||0};if(containerHeight&&navbar&&viewport&&viewport.getComputedStyle('width')!=='auto'){result.height=containerHeight-(bottomNavbar?bottomNavbar.get('offsetHeight'):0);result.width=Math.floor(parseFloat(viewport.getComputedStyle('width')));result.height=Math.max(result.height,minheight||0);result.width=Math.max(result.width,minwidth||0);}return result;};utils.getUnitSeries=function(unit,db){return db.services.getServiceByName(unit.id.split('/')[0]).get('series');};utils.getName=function(id){var parts=id.split('/');var idParts=parts[parts.length-1].split('-');if(!isNaN(idParts[idParts.length-1])){idParts.pop();}return idParts.join('-');};utils.pluralize=function(word,object,plural_word,options){var plural=false;if(typeof object==='number'){plural=object!==1;}if(object){if(object.size){plural=object.size()!==1;}else if(object.length){plural=object.length!==1;}}if(plural){if(typeof plural_word==='string'){return plural_word;}else{return word+'s';}}else{return word;}};utils.deployTargetDispatcher=function(entityId){var charmstore=this.get('charmstore');var failureNotification=function failureNotification(error){var message='Unable to deploy target: '+entityId;try{message=JSON.parse(error.currentTarget.responseText).Message;}catch(e){console.error(e);}this.db.notifications.add({title:'Error deploying target.',message:message,level:'error'});};if(entityId.indexOf('bundle/')>-1){charmstore.getBundleYAML(entityId,function(error,bundleYAML){if(error){failureNotification(error);}else{this.bundleImporter.importBundleYAML(bundleYAML);}}.bind(this));}else{charmstore.getEntity(entityId.replace('cs:',''),function(error,charm){if(error){failureNotification(error);}else{charm=charm[0];var config={},options=charm.get?charm.get('options'):charm.options;Object.keys(options).forEach(function(key){config[key]=options[key]['default'];});this.env.deploy(charm.get?charm.get('id'):charm.id,charm.get?charm.get('name'):charm.name,config,undefined,1,{},null);this.fire('autoplaceAndCommitAll');}}.bind(this));}var currentState=this.state.get('current');delete currentState.app.deployTarget;this.navigate(this.state.generateUrl(currentState));},utils.determineEntityDataType=function(entityData){if(entityData&&entityData.id&&entityData.id.indexOf('bundle')>-1){return'bundle';}return'charm';};utils.createMachinesPlaceUnits=function(db,env,service,numUnits,constraints){var machine;for(var i=0;i<parseInt(numUnits,10);i+=1){machine=db.machines.addGhost();env.addMachines([{constraints:constraints}],function(machine){db.machines.remove(machine);}.bind(this,machine),{modelId:machine.id});env.placeUnit(utils.addGhostAndEcsUnits(db,env,service,1)[0],machine.id);}};utils.addGhostAndEcsUnits=function(db,env,service,unitCount,callback){var serviceName=service.get('id'),unitCount=parseInt(unitCount,10),units=[],displayName,ghostUnit,unitId,unitIdCount;var parseId=function parseId(u){return parseInt(u.id&&u.id.split('/')[1]||u,10);};var serviceUnits=service.get('units').toArray();var highestIndex=serviceUnits.reduce(function(prev,curr){return Math.max(parseId(prev),parseId(curr));},0);if(serviceName.indexOf('$')>0){displayName=service.get('displayName').replace(/^\(/,'').replace(/\)$/,'');}else{displayName=serviceName;}for(var i=1;i<=unitCount;i+=1){unitIdCount=serviceUnits.length===0?highestIndex:highestIndex+i;unitId=serviceName+'/'+unitIdCount;ghostUnit=db.addUnits({id:unitId,displayName:displayName+'/'+unitIdCount,charmUrl:service.get('charm'),subordinate:service.get('subordinate')});env.add_unit(serviceName,1,null,removeGhostAddUnitCallback.bind(null,ghostUnit,db,callback),{modelId:unitId});units.push(ghostUnit);}return units;};function removeGhostAddUnitCallback(ghostUnit,db,callback,e){ghostUnit.service=e.applicationName;db.removeUnits(ghostUnit);if(typeof callback==='function'){callback(e,db,ghostUnit);}}utils.removeGhostAddUnitCallback=removeGhostAddUnitCallback;utils.destroyService=function(db,env,service,callback){if(service.name==='service'){env.destroyApplication(service.get('id'),utils._destroyServiceCallback.bind(this,service,db,callback),{modelId:null});}else if(service.get('pending')){db.services.remove(service);service.destroy();}else{throw new Error('Unexpected model type: '+service.name);}};utils._destroyServiceCallback=function(service,db,callback,evt){if(evt.err){db.notifications.add({title:'Error destroying service',message:'Service name: '+evt.applicationName,level:'error',link:undefined,modelId:service});}else{db.relations.remove(service.get('relations'));db.notifications.add({title:'Destroying service',message:'Service: '+evt.applicationName+' is being destroyed.',level:'important'});}if(callback){callback();}};utils.clearState=function(topo){topo.fire('clearState');};utils.getUnitStatusCounts=function(units){var unitStatuses={uncommitted:{priority:3,size:0},started:{priority:2,size:0},pending:{priority:1,size:0},error:{priority:0,size:0}};var agentState;units.forEach(function(unit){agentState=unit.agent_state||'uncommitted';if(!unitStatuses[agentState]){unitStatuses[agentState]={priority:99,size:0};}unitStatuses[agentState].size+=1;});return unitStatuses;};utils.getUnplacedUnitCount=function(units){return units.filterByMachine(null).length;};utils.destroyRelations=function(db,env,relations,callback){for(var i=0;relations.length>i;i++){var relationId=relations[i];var relation=db.relations.getById(relationId);var endpoints=relation.get('endpoints');env.remove_relation(endpoints[0],endpoints[1],callback);}};utils.createRelation=function(db,env,relations,callback){var endpoints=[[relations[0].service,{name:relations[0].name,role:'client'}],[relations[1].service,{name:relations[1].name,role:'server'}]];var relationId='pending-'+endpoints[0][0]+':'+endpoints[0][1].name+endpoints[1][0]+':'+endpoints[1][1].name;db.relations.add({relation_id:relationId,'interface':endpoints[0][1].name,endpoints:endpoints,pending:true,scope:'global',display_name:'pending'});env.add_relation(endpoints[0],endpoints[1],function(e){db.relations.remove(db.relations.getById(relationId));db.relations.create({relation_id:e.result.id,type:e.result['interface'],endpoints:endpoints,pending:false,scope:e.result.scope});}.bind(this));};utils.getAvailableEndpoints=function(endpointsController,db,getEndpoints,applicationFrom,applicationTo){var relatableEndpoints=getEndpoints(applicationFrom,endpointsController)[applicationTo.get('id')];var existing=utils.getRelationDataForService(db,applicationTo,applicationFrom);if(existing.length===0){return relatableEndpoints;}var availableEndpoints=relatableEndpoints.filter(function(relation){return!existing.some(function(existingRelation){return relation[0].name===existingRelation.far.name||relation[1].name===existingRelation.near.name;});});return availableEndpoints;};utils.getRelatableApplications=function(db,endpoints){return Object.keys(endpoints).map(function(appName){return db.services.getById(appName);});};utils.destroyUnits=function(env,units,callback){env.remove_units(units,callback);};utils.getIconPath=function(charmId,isBundle,env){var cfg=window.juju_config,charmstoreURL=cfg&&cfg.charmstoreURL||'',localIndex=charmId.indexOf('local:'),path;if(localIndex>-1&&env){path=env.getLocalCharmFileUrl(charmId,'icon.svg');}else if(localIndex===-1){if(typeof isBundle==='boolean'&&isBundle){var staticURL='';if(window.juju_config&&window.juju_config.staticURL){staticURL=window.juju_config.staticURL+'/';}var basePath=staticURL+'static/gui/build/app';path=basePath+'/assets/images/non-sprites/bundle.svg';}else{charmId=charmId.replace(/^[^:]+:/,'');path=charmstoreURL+[window.jujulib.charmstoreAPIVersion,charmId,'icon.svg'].join('/');}}else{path='static/gui/build/app/assets/images/non-sprites/charm_160.svg';}return path;};var URL_RE=/\b((?:(?:https?|ftp):(?:\/{1,3}|[a-z0-9%])|[a-z0-9.\-]+[.](?:com|net|org|edu|gov|mil|aero|asia|biz|cat|coop|info|int|jobs|mobi|museum|name|post|pro|tel|travel|xxx|ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cs|cu|cv|cx|cy|cz|dd|de|dj|dk|dm|do|dz|ec|ee|eg|eh|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|Ja|sk|sl|sm|sn|so|sr|ss|st|su|sv|sx|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw)\/)(?:[^\s()<>{}\[\]]+|\([^\s()]*?\([^\s()]+\)[^\s()]*?\)|\([^\s]+?\))+(?:\([^\s()]*?\([^\s()]+\)[^\s()]*?\)|\([^\s]+?\)|[^\s`!()\[\]{};:'".,<>?«»“”‘’])|(?:[a-z0-9]+(?:[.\-][a-z0-9]+)*[.](?:com|net|org|edu|gov|mil|aero|asia|biz|cat|coop|info|int|jobs|mobi|museum|name|post|pro|tel|travel|xxx|ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cs|cu|cv|cx|cy|cz|dd|de|dj|dk|dm|do|dz|ec|ee|eg|eh|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|Ja|sk|sl|sm|sn|so|sr|ss|st|su|sv|sx|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw)\b\/?(?!@)))/ig;utils.linkify=function(str){var sanitizedStr=str.replace(/&/g,'&amp;').replace(/</g,'&lt;').replace(/>/g,'&gt;');var links=sanitizedStr.match(URL_RE);if(links){links.forEach(function(link){var href=link.replace(/"/g,'&quot;');sanitizedStr=sanitizedStr.replace(link,'<a href="'+href+'" target="_blank">'+link+'</a>');});}return sanitizedStr;};utils.numToLetter=function(num){var remainder=num%26;var multiple=num/26|0;var char='';if(remainder){char=String.fromCharCode(96+remainder);}else{multiple--;char='z';}return multiple?utils.numToLetter(multiple)+char:char;};utils.letterToNum=function(str){var num=0;var characters=str.split('');var characterLength=characters.length;characters.forEach(function(letter,characterPosition){var base=Math.pow(26,characterLength-characterPosition-1);num+=base*(str.charCodeAt(characterPosition)-96);});return num;};utils.generateServiceName=function(charmName,services){var counter=arguments.length<=2||arguments[2]===undefined?0:arguments[2];var name=counter>0?charmName+'-'+utils.numToLetter(counter):charmName;var match=services.some(function(service){return service.get('name')===name;});return match?utils.generateServiceName(charmName,services,counter+=1):name;};utils.compareSemver=function(a,b){a=a.split('-')[0];b=b.split('-')[0];var pa=a.split('.');var pb=b.split('.');for(var i=0;i<3;i++){var na=Number(pa[i]);var nb=Number(pb[i]);if(na>nb)return 1;if(nb>na)return-1;if(!isNaN(na)&&isNaN(nb))return 1;if(isNaN(na)&&!isNaN(nb))return-1;}return 0;};utils.switchModel=function(createSocketURL,switchEnv,env,uuid,modelList,name,callback){var switchModel=utils._switchModel.bind(this,createSocketURL,switchEnv,env,uuid,modelList,name,callback);var currentChangeSet=env.get('ecs').getCurrentChangeSet();if(Object.keys(currentChangeSet).length>0){utils._showUncommittedConfirm(switchModel);return;}switchModel();};utils._showUncommittedConfirm=function(action){var buttons=[{title:'Cancel',action:utils._hidePopup.bind(this),type:'base'},{title:'Continue',action:action,type:'destructive'}];ReactDOM.render(React.createElement(window.juju.components.ConfirmationPopup,{buttons:buttons,message:'You have uncommitted changes to your model. You will '+'lose these changes if you continue.',title:'Uncommitted changes'}),document.getElementById('popup-container'));};utils._hidePopup=function(){ReactDOM.unmountComponentAtNode(document.getElementById('popup-container'));};utils._switchModel=function(createSocketURL,switchEnv,env,uuid,modelList,name,callback){utils._hidePopup();this.showConnectingMask();this.changeState({sectionA:{component:null,metadata:null},sectionB:{component:null,metadata:null},sectionC:{component:null,metadata:null}});env.set('environmentName',name);this.set('jujuEnvUUID',uuid);var username,password,address,port;if(uuid&&modelList){var found=modelList.some(function(model){if(model.uuid===uuid){username=model.user;password=model.password;if(model.hostPorts&&model.hostPorts.length){var hostport=model.hostPorts[0].split(':');address=hostport[0];port=hostport[1];}return true;}});if(!found){console.log('No user credentials for model: ',uuid);}var socketUrl=createSocketURL(uuid,address,port);switchEnv(socketUrl,username,password,callback);}else{switchEnv(null,null,null,callback);}};utils.showProfile=function(ecs,changeState){var currentChangeSet=ecs.getCurrentChangeSet();if(Object.keys(currentChangeSet).length>0){utils._showUncommittedConfirm(utils._showProfile.bind(this,ecs,changeState,true));return;}utils._showProfile(ecs,changeState,false);};utils._showProfile=function(ecs,changeState){var clear=arguments.length<=2||arguments[2]===undefined?false:arguments[2];utils._hidePopup();if(clear){ecs.clear();}changeState({sectionB:{component:'profile',metadata:null}});};utils.listModels=function(env,jem,user,gisf,callback){if(!gisf&&(!env||env.findFacadeVersion('ModelManager')===null&&env.findFacadeVersion('EnvironmentManager')===null)){var environmentName=env.get('environmentName');var username=user&&user.usernameDisplay;callback(null,{models:[{name:environmentName,ownerTag:username,uuid:'',lastConnection:'now'}]});return;}var xhr;if(jem){xhr=jem.listModels(callback);}else{xhr=env.listModelsWithInfo(callback.bind(null));}return xhr;};utils.deploy=function(env,jem,users,autoPlaceUnits,createSocketURL,appSet,committed,callback){var autoplace=arguments.length<=8||arguments[8]===undefined?true:arguments[8];var model=arguments[9];var credential=arguments[10];var cloud=arguments[11];var region=arguments[12];if(autoplace){autoPlaceUnits();}if(committed){env.get('ecs').commit(env);callback();return;}jem.newModel(users.jem.user,model,credential,{cloud:cloud,region:region},null,utils._newModelCallback.bind(this,env,createSocketURL,appSet,callback));};utils._newModelCallback=function(env,createSocketURL,appSet,callback,error,model){if(error)throw error;var pathParts=model.hostPorts[0].split(':');env.setCredentials({user:'user-'+model.user,password:model.password});var socketURL=createSocketURL(model.uuid,pathParts[0],pathParts[1]);appSet('jujuEnvUUID',model.uuid);appSet('socket_url',socketURL);env.set('socket_url',socketURL);env.connect();utils._detachOnLoginHandler();this._onLoginHandler=env.on('login',function(model){utils._detachOnLoginHandler();env.get('ecs').commit(env);callback();});};utils._detachOnLoginHandler=function(){if(this._onLoginHandler){this._onLoginHandler.detach();this._onLoginHandler=null;}};},'0.1.0',{requires:['base-build','confirmation-popup','escape','node','view','panel','json-stringify','datatype-date-format']});